import netscape.application.*;
import netscape.util.*;
import java.awt.AWTError;
import java.io.*;
import java.net.*;
import java.util.StringTokenizer ;
import netscape.javascript.*;


public class javaGUI extends Application 
{
public static final int   PAUSE          = 10;
public static final int   PUTBREAKONOFF  = 11;
public static final int   STEPOVER       = 12;
public static final int   NSTEPOVER      = 13 ;
public static final int   STEPINTO       = 14;
public static final int   NSTEPINTO      = 15;
public static final int   CONTINUE       = 16;
public static final int   RUN            = 17;
public static final int   STOP           = 18;
public static final int   NITERATION     = 19;
public static final int   GOUNTIL        = 20;
public static final int   DISPLAY        = 21;
public static final int   SETVARIABLE    = 22;
public static final int   SETPARVAR      = 23; 
public static final int   CONNECT        = 24; 
public static final int   GOTOCURSOR     = 25;
public static final int   INTERPRETER    = 26;
public static final int   ENDOFPROGRAM   = 27;
public static final int   DISARRAYSECTION = 28;
public static final int   SCIVISENV       = 29;
public static final int   ATTACHFCALL     = 30;
public static final int   DETACHFCALL     = 31 ;
public static final int   GOTOSTACKDOWN   = 32;
public static final int   GOTOSTACKUP     = 33 ; 
public static final int   SCIVIS_FUNCTION_LIST = 34;
public static final int   ACTION_LIST     = 35;
public static final int   ADD_ACTION      = 36;
public static final int   DELETE_ACTION   = 37;
public static final int   GET_PROFILE_DATA = 38;
public static final int   SEND_LOCALS     = 39;
public static final int   GET_FUNCTION    = 40;
public static final int   WEBFLOW         = 41 ;
public static final int   STORE_CONFIG    = 42;
public static final int   APPLY_CONFIG    = 43;
public static final int   SEND_CONFIGS    = 44;
public static final int   ACKCOMMAND      = 45;
public static final int   APPCOMMAND      = 46;
public static final int   VARVALUE        = 47;
public static final int   REGISTER_CLIENT = 48;
public static final int   JSWINDOW        = 49;
public static final int   ADMIN           = 50;
public static final int   START           = 51;
public static final int   SAGECOMMAND     = 52 ;  
public static final int   SAGECOMMAND_ACK = 53;   
        

public static final int    T_INT         =  551 ;
public static final int    T_FLOAT       =  552;
public static final int    T_DOUBLE      =  553;
public static final int    T_CHAR        =  554;
public static final int    T_BOOL        =  555;
public static final int    T_STRING      =  556;
public static final int    T_ENUM        =  557;
public static final int    T_SUBRANGE    =  558;
public static final int    T_LIST        =  559;
public static final int    T_ARRAY       =  560;
public static final int    T_RECORD      =  561;
public static final int    T_LONG        =  587;
public static final int    T_SHORT       =  588;
public static final int    T_BYTE        =  589;

public static final int    GETNEWFILE    = -1;
public static final int    STOPPROGRAM   = -2;
public static final int    ABNORMALTERM  = -3;
public static final int    ARRAYSECERROR = -4;
public static final int    UNUSEDDIM     = -999;
public static final int    RUNTIME_ERROR   = -1;
public static final int    COMPILE_ERROR   = -2;

public static final int    OPENPROJWIN     = 1;
public static final int    OPENSCIVIZWIN   = 2;
public static final int    OPENINTERPWIN   = 3;

public static final int    SIMD            = 1;
public static final int    MIMD            = 2;  

public static final int    APPLET          = 1; 
public static final int    PARNODE         = 2; 
public static final int    MANAGER         = 3;
 
public  DesignManager manager;
static java.applet.Applet myApplet;

 public void init() {
  

   
   super.init();
   myApplet = AWTCompatibility.awtApplet(); //getApplet().getAppletContext() ;

   manager = new DesignManager();
   manager.addMenuItems();
   manager.addAllButtons();
   manager.addScrollBars ();
   manager.addDisplayWindow();
   
   manager.FinishDesign();

  }

  public DesignManager givemanager()
  {
      return (manager);
  }
}

class statusInfo
{
     public int sourceCommand, sourcepid, ackstatus,myline;
     String errmsg,recvAck ;
  
     public statusInfo(int sourceCommand_,int sourcepid_,int myline_,
			 int ackstatus_,String errmsg_,String recvAck_)
     {
       int si,ei;
       
       sourceCommand = sourceCommand_;
       sourcepid     = sourcepid_;
       myline        = myline_;
       ackstatus     = ackstatus_;
       errmsg        = errmsg_;
       recvAck       = recvAck_;
       
      }
    
     public int retstatus()
     {
         return ackstatus;
     }

     public int line()
     {
        return myline;
     }
    public String errormsg()
    {
       return errmsg;
    }
   public String receivedAck()
   {
     return recvAck;
   }
  

  
}

class HPFServerThread extends Thread{

String protocol,host,command;
int    port;

public HPFServerThread (String protocol_,String host_,int port_,
			String command_)
  {
    protocol = protocol_;
    host     = host_;
    command  = command_;
    port     = port_;
  }

public void run()
   {
  
     URL url_file=null;
     BufferedReader theHTML = null;
     String s=null ;
     
     try
      {
        String thisLine;
	url_file = new URL(protocol,host,port,command);
	// Disable cache
	url_file.openConnection().setUseCaches(false);
        theHTML = new BufferedReader(new InputStreamReader(url_file.openStream()));
      }catch (MalformedURLException ev)
	{
          System.out.println("URL error in HPFServerThread (run) " + ev);
	} 
      catch (IOException ev) 
	{
          System.out.println("IOException in HPFServerThread (run)"+ev); 
        }

       boolean flag = true;
       int counter=0;
       
       while(flag)
        {
	  
        try {
            s = theHTML.readLine();
	    if (s == null){ //end of file
	      yield();
	      try{
		sleep(100000);
	      }catch(InterruptedException e){
		System.out.println("Interrupted.. in reading results");
	      }
	    }
	    else
              System.out.println("line : "+s);
	    
         }
         catch (IOException ev) 
         {
             System.out.println("IOException in HPFServerThread (run)"+ev); 
	     return;
	     
	 }
	}
   }
  
  

}




class appletDaemon extends Thread{

  HPFTextView hpftext;
  

public appletDaemon (HPFTextView hpftext_)
  {
    hpftext = hpftext_;
  }

public void run() 
   {
     boolean flag=true;

     System.out.println("appletDaemon starts running !!!");
     
     while(flag)
       {   
	  // There is one acknowledment
	 try{
	  if (hpftext.rlib.available())
	    process_ack();
	  else{
	    try{
	      sleep(100); //sleep 100 milliseconds
	    }catch(InterruptedException e){
	      System.out.println("Interrupted..");
	    }
	  }
	 }catch(IOException e){
	   System.out.println("I am getting IOException during available()");
	 }
       }
     	 
     
   }
  
  
public void  process_ack() throws IOException
{
  
  int new_command = hpftext.rlib.recv_int();
  System.out.println("Deamon got the command = "+new_command );
  
  switch(new_command){
    case javaGUI.PAUSE:
      hpftext.sendPauseCommand_ack();
      break;
    case javaGUI.PUTBREAKONOFF:
      hpftext.putBreakPointOnOff_ack();
      break;
    case javaGUI.STEPINTO: 
      hpftext.stepInto_ack();
      break;
    case javaGUI.STEPOVER: 
      hpftext.stepOver_ack();
      break;      
    case javaGUI.NSTEPINTO:
      hpftext.NStepInto_ack();
      break;
    case javaGUI.NSTEPOVER:
      hpftext.NStepOver_ack();
      break;  
    case javaGUI.NITERATION:
      hpftext.nIteration_ack();
      break;
    case javaGUI.CONTINUE:
      hpftext.makeContinue_ack();
      break;
    case javaGUI.DISPLAY:
      hpftext.displayVariable_ack();
      break;
    case javaGUI.SETVARIABLE:
      hpftext.setVariable_ack();
      break;
    case  javaGUI.GOTOCURSOR: 
      hpftext.goToCursor_ack();
      break;
    case  javaGUI.INTERPRETER:  
      hpftext.sendHPFStmts_ack();
      break;
    case  javaGUI.DISARRAYSECTION:
      hpftext.getArraySection_ack()  ;
      break;
    case  javaGUI.SCIVISENV:
      hpftext.sendSciVisEnv_ack() ;
      break;

    case  javaGUI.SCIVIS_FUNCTION_LIST:
      hpftext.getSciVisFlist_ack() ;
      break;
    case  javaGUI.ACTION_LIST:
      hpftext.getActionPoints_ack();
      break;
    
    case  javaGUI.ADD_ACTION:
      hpftext.add_action_ack() ;
      break;
    case  javaGUI.DELETE_ACTION:
      hpftext.delete_action_ack() ;
      break;     
    case  javaGUI.GET_PROFILE_DATA:  
      hpftext.getProfileData_ack()  ;
      break;
    case  javaGUI.SEND_LOCALS:    
      hpftext.getLocalVars_ack();
      break;
    case  javaGUI.GET_FUNCTION : 
      hpftext.getFunctionParams_ack();
      break;
    case  javaGUI.STORE_CONFIG:
      hpftext.store_config_ack();
      break;
    case  javaGUI.APPLY_CONFIG:  
      hpftext.applyConfig_ack();
      break;
    case  javaGUI.SEND_CONFIGS:  
      hpftext.recvConfigFiles_ack();
      break;
    case javaGUI.JSWINDOW:  
      hpftext.update_jswindow();
      break;
    case javaGUI.START:
      hpftext.start_ack();
      break;
    case javaGUI.STOP:  
      hpftext.stopAndKillApplication_ack();
      break;
      
    case javaGUI.GOTOSTACKDOWN:  
      hpftext.makeMoveDown_ack();
      break;
    case javaGUI.GOTOSTACKUP:  
      hpftext.makeMoveUp_ack();
      break;  
      
       
  }
}
}





  
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
class HPFTextView extends TextView  implements Target
{
  Vector breakPoints;
  Vector actionPoints;
  Vector breakFileIndex;
  Vector actionFileIndex;
    
  Rect pc; // program counter
  int  currentLineNumber;
  Range textLineRanges[];
  Vector textLineRects[];
  readValue readWindow ; 
  String HTTPHost ; //gets its value from applet 
  int    HTTPPort ; //gets its value from applet
  String HTTPFile;
  String ManagerServerPort = "3339";
  String SciVisHost;     //= HTTPHost
  String SciVisPort        = "7654";
  String SageServerHost; //= HTTPHost
  String SageServerPort    = "3335";
  String applicationType   = "1"; // is it SIMDI(1) or MIMD(2) 
  String  numOfProcs       = "2";
  InternalWindow   PreferenceWindow;
  
  String HPFFileName;
  String HPFApplication;
  public connection managerCon ;
  recv_module rlib;
  send_module slib;
  DesignManager manager;
  Vector textLines;
  Vector fileNames;
  Range currentRange;
  int curX,curY;
  HPFServerThread managerServerThread;
  appletDaemon DaemonThread;
  
  public String currentProjectName;
  public String currentFileName;
  public String HPFSOURCEDIR = "/globus/hpf/";
  public String CGIBINDIR    = "/cgi-shl/globus/VPL-bin/";
  public int []selected_pids;
  public String setvar_NameValue;
  JSObject jswin=null;
            
public boolean isTransparent()
  {
    return false;
  }
  


  
public HPFTextView(int x, int y, int width, int height,DesignManager manager_ )
  throws IOException
{
    super(x,y,width,height);
    breakPoints     = new Vector();
    actionPoints    = new Vector();
    breakFileIndex  = new Vector();
    actionFileIndex = new Vector();

    pc = new Rect();
    //super.setBuffered(true);
    setTextColor(Color.gray);
    manager = manager_;
    fileNames = new Vector();
    textLines = new Vector();

    URL surl  = javaGUI.myApplet.getDocumentBase();
    HTTPHost = surl.getHost();
    HTTPPort = surl.getPort();
    HTTPFile = surl.getFile();
    SciVisHost     = "hookh.npac.syr.edu";
    SageServerHost = "hookh.npac.syr.edu";
    try{
        jswin = JSObject.getWindow(javaGUI.myApplet);
     }catch (Exception e){
	  e.printStackTrace();}
   
    //create necessary space to keep the interested pids
    selected_pids = new int[new Integer(numOfProcs).intValue()];

}
public void sendPauseCommand_ack() throws IOException
{
  // get result from HPF server
   statusInfo status = readAck(javaGUI.PAUSE);
   if (status.retstatus() < 0)
      return;
   int newLineNum =  status.line();
   gotoLine(status);
   System.out.println("after Pause : new line Num :"+newLineNum);
    
}


public void sendPauseCommand() throws IOException
{
  int buflen = 8;
  send_command_tag(buflen,javaGUI.PAUSE,selected_pids);  
    
}
  

public void  sendHPFStmts(String oneLine)
{

   System.out.println("I got from JS : "+oneLine);
   try{
      //send interpreter command to manager
      oneLine = oneLine + "\n";
      int buflen = packed_string_length(oneLine)+8;
      send_command_tag(buflen,javaGUI.INTERPRETER,selected_pids);
      slib.send_String(oneLine);
      System.out.println("I am sending this : "+oneLine);
    }catch(IOException e){
	System.out.println("IOException in Interpreter Submit "+e);}
}


public  void sendHPFStmts_ack() throws IOException
{

   statusInfo status = readAck(javaGUI.INTERPRETER);
   String ackstr = status.errormsg();
   
    // Update interpreter javascript window
   String []jsargs = new String[1];
   jsargs[0] = ackstr;
   jswin.call("sendHPFStmts_ack_interpreter_window",jsargs);
            
}


public void setTextViewContent(String host,int port,String fileName)
{
    int startIndex,endIndex,index;
    Integer ival ;

    int sindex = fileName.lastIndexOf('/');
    if (sindex >=0)
      fileName = fileName.substring(sindex+1);
    else 
    {
       sindex = fileName.lastIndexOf('\\');
       fileName = fileName.substring(sindex+1);
    }
          
    //set current file name
    currentFileName = fileName;
    
    //Delete old content before
    setString("");

    startIndex   = -2;
    endIndex     = -2;
    index = fileNames.indexOf(fileName);
    if  (index >= 0){ //found
       ival = (Integer)(fileNames.elementAt(index+1));
       startIndex   = ival.intValue();
       ival = (Integer)(fileNames.elementAt(index+2));
       endIndex     = ival.intValue();
    }
 
    if (startIndex == -2) //Not Found
    {
       System.out.println("I am receiving file : -2"+fileName);
  	 
       startIndex = textLines.size(); 
       Vector NewTextLines = readRemoteFile(host,port,HPFSOURCEDIR+fileName);

       textLines.addElements(NewTextLines);
       endIndex = textLines.size();
       fileNames.addElement(fileName);
       fileNames.addElement(new Integer(startIndex));
       fileNames.addElement(new Integer(endIndex));
    }
    //found but startIndex and endIndex is not initialized
    else if (startIndex == -1)
    {
       System.out.println("I am receiving file : -1"+fileName);
 	 
       startIndex = textLines.size(); 
       Vector NewTextLines = readRemoteFile(host,port,HPFSOURCEDIR+fileName);
       textLines.addElements(NewTextLines);
       endIndex = textLines.size();

       fileNames.setElementAt(new Integer(startIndex),index+1);
       fileNames.setElementAt(new Integer(endIndex),index+2);
    }
    else
      System.out.println("Using old one :"+fileName);
    
    textLineRanges = new Range[textLines.size()];
    textLineRects  = new Vector[textLines.size()];
    for(int i=startIndex,j=0;i<endIndex;i++,j++){
       String s = (String)(textLines.elementAt(i));
       String ts = "\t"+j+"> ";
       ts += s;
       ts += "\n\r";
       textLineRanges[j] = appendString(ts);
       textLineRects[j]  = rectsForRange(textLineRanges[j]);
    }
    
}

public void UpdateTextViewContent(String host,int port,String fileName)
{
    int startIndex,endIndex,index;
    Integer ival;
    int i,j ;

    //Delete old content before
    setString("");
    fileNames.removeAllElements();
    textLines.removeAllElements(); 

    startIndex = textLines.size(); 

    int sindex = fileName.lastIndexOf('/');
    if (sindex >=0)
       fileName = fileName.substring(sindex+1);
    else 
    {
       sindex = fileName.lastIndexOf('\\');
       fileName = fileName.substring(sindex+1);
    }

    Vector NewTextLines = readRemoteFile(host,port,HPFSOURCEDIR+fileName);
    //Vector NewTextLines = readRemoteFile(host,port,"/hpf/"+fileName);
    textLines.addElements(NewTextLines);
    endIndex = textLines.size();
    fileNames.addElement(fileName);
    fileNames.addElement(new Integer(startIndex));
    fileNames.addElement(new Integer(endIndex));
 
    textLineRanges = new Range[textLines.size()];
    textLineRects  = new Vector[textLines.size()];
    for(i=startIndex,j=0;i<endIndex;i++,j++){
       String s = (String)(textLines.elementAt(i));
       String ts = "\t"+j+"> ";
       ts += s;
       ts += "\n\r";
       textLineRanges[j] = appendString(ts);
       textLineRects[j]  = rectsForRange(textLineRanges[j]);
    }
    System.out.println("I am receivinf fil : "+fileName);
    
}


public void drawView (Graphics g)
{
   super.drawView(g);
   
   g.setColor(new Color(255,255,255));
   g.setXORMode(Color.green);

   //put program counter as filled rectangle;
   int xPoints[] = new int[3];
   int yPoints[] = new int[3];
   xPoints[0] = pc.x;
   xPoints[1] = pc.x;
   xPoints[2] = (int)(pc.x+((pc.height)*(Math.sqrt(3.0f)))/2.0f);
   yPoints[0] = pc.y;
   yPoints[1] = pc.y+pc.height;
   yPoints[2] = pc.y+(pc.height)/2;
   g.fillPolygon(xPoints,yPoints,3);

   g.setColor(new Color(255,255,255));
   g.setXORMode(Color.green);
   //make green the current line
   g.fillRect(pc.x+pc.height,pc.y,pc.width,pc.height);

  
   int curFileIndex = fileNames.indexOf(currentFileName);
   for(int i=0;i<breakPoints.size();i++){
      g.setColor(new Color(255,255,255));
      g.setXORMode(Color.red);
      Rect rect = (Rect)(breakPoints.elementAt(i));
 
      Integer nextF = (Integer)(breakFileIndex.elementAt(i));
      int nextIndex = nextF.intValue();
      
      if (curFileIndex == nextIndex)
      {
	//put stop red ball at the breakPoint
	g.fillArc(rect.x, rect.y, (int)(0.85f*rect.height), 
               (int)(0.85f*rect.height), 0, 360);
	//make red the reakpoint line
	g.fillRect(rect.x+rect.height, rect.y,rect.width,rect.height);
      }
      else
	System.out.println("Sorry this line does not have break :"+i+
			curFileIndex+"-"+ nextIndex  );
      
   }

   for(int i=0;i<actionPoints.size();i++){
      g.setColor(new Color(255,255,255));
      g.setXORMode(Color.cyan);
      Rect rect = (Rect)(actionPoints.elementAt(i));
 
      Integer nextF = (Integer)(actionFileIndex.elementAt(i));
      int nextIndex = nextF.intValue();

      if (curFileIndex == nextIndex)  
      {
	//make yellow the actionpoint line
	g.fillRect(rect.x+rect.height, rect.y,rect.width,rect.height);
      }
      else
	System.out.println("Sorry this line does not have action :"+i+
			curFileIndex+"-"+ nextIndex  );
   }

   
}

public void keyDown(KeyEvent event) 
{ 
  
  super.keyDown(event);
  
  if (event.key == KeyEvent.F4_KEY){
    System.out.println("F4 was pressed");
    try{
      putBreakPointOnOff();
    }catch(IOException ev){
      System.out.println("IOException in keyDown "+ev);}
  }

  //TextPositionInfo context = _selection._insertionPointInfo;
  //Range prange = new Range(0,length());
  //Vector vector = paragraphsForRange(prange);
  //Range crange  = paragraphForPoint(context._x,context._y);
  //int lineNumber = vector.indexOf(crange);
  //System.out.println("LineNumber ...... ="+lineNumber);
  
} 

public statusInfo readAck(int sourceCommand) throws IOException
{
   String errMsg=null;
   int status = 0;

   // sourceCommand was received before
   // receive myline+pid+errcode+errstring
   int myline         = rlib.recv_int(); 
   int pid            = rlib.recv_int();
   int source_command = sourceCommand;
   System.out.println("ReadAck:myline:"+myline+"pid:"+pid+
		      "source_com:"+sourceCommand);
   
   // get result from HPF server
   try{
      status   = rlib.recv_int();
      errMsg   = rlib.recv_String().toString();  
   }catch(IOException ev){
     System.out.println("IOException in  readAck "+ev);}
   System.out.println("ReadAck:status:"+status+"errMsg:"+errMsg);
   
   String saveMsg = errMsg;
   errMsg = "Processor("+pid+"):"+"(command tag"+source_command+"):"+
            "errMsg("+errMsg+"):"+"LineNumber("+myline+"):"+
            "errcode("+status+")"+"\n" ;
   
   System.out.println("After readAck ..status :"+ status);
   // send command "errMsg" to display window
   CommandEvent cev = new CommandEvent((Target)manager,"Display",errMsg);
   Application.application().eventLoop().addEvent(cev);

   statusInfo ack_stat = new statusInfo(source_command,pid, myline,
					 status, errMsg,saveMsg);
   return ack_stat;
   // later for each specific command, receive the results of commands
}


public String interpreter_readAck() throws IOException
{
   String errMsg=null;
   int status = 0;

   // receive sourceCommand+pid+myline+errcode+errstring
   int source_command = rlib.recv_int();
   int pid            = rlib.recv_int();
   int myline         = rlib.recv_int();

   // get result from HPF server
   try{
      status   = rlib.recv_int();
      errMsg   = rlib.recv_String().toString();  
   }catch(IOException ev){
     System.out.println("IOException in  readAck "+ev);}

   errMsg = "Processor("+pid+"):"+source_command+"(command tag):"+errMsg ;
   System.out.println("After readAck ..status :"+ status);
   return errMsg;
   
}

public void start_ack()throws IOException
{
  System.out.println("I am getting ack. for start command ");
  statusInfo status = readAck(javaGUI.START);
  gotoLine(status); // array in JAVA starts at zero   
  currentLineNumber = status.line()-1;
  
}


public void putBreakPointOnOff_ack() throws IOException
{

   //get result from HPF server
   statusInfo status = readAck(javaGUI.PUTBREAKONOFF);
   int lineNumber = status.line();
   Rect break_rect  = (Rect)(textLineRects[lineNumber-1].elementAt(0));
   int break_curX = break_rect.x;
   int break_curY = break_rect.y;

   if (status.retstatus() ==  0)
   {
      Range range = runForPoint(break_curX,break_curY);
      Vector vecs = rectsForRange(range);

      if (!breakPoints.contains(vecs.elementAt(0))){
         breakPoints.addElement(vecs.elementAt(0));
	 int findex  = fileNames.indexOf(currentFileName);
	 breakFileIndex.addElement(new Integer(findex));
      }
      else{
	 int breakIndex = breakPoints.indexOf(vecs.elementAt(0));
         breakPoints.removeElement(vecs.elementAt(0));
	 breakFileIndex.removeElementAt(breakIndex);
      }
      draw();
   }
   System.out.println("after putbreakpoint to line :"+(lineNumber+1));
}

public void send_command_tag(int buflen,int command,int []pids)
  throws IOException
{
    
   slib.send_int(javaGUI.APPCOMMAND);
   //buflen = buflen + (pids.length)*4;
   // IMPORTANT !!! later change the following to reflect the actula processor
   // numbers and pids array 
   buflen = buflen - 4;
   slib.send_int(buflen); //buffer length = length of command+pid+parameters
   slib.send_int(command);
   //   slib.send_int(pids.length);
   //for(int k=0;k<pids.length;k++)
   //  slib.send_int(pids[k]);
   //send later necessary parameters for each specific command 
}

public void putBreakPointOnOff(int N)throws IOException
{
   // find the line number on which we put breakPoint
   int lineNumber = N;
   
   //send breakPoint command to HPF server:
   //command tag + lineNumber
   send_command_tag(12,javaGUI.PUTBREAKONOFF,selected_pids);
   slib.send_int(lineNumber+1);//we stars lines at zero: i->i+1//
   System.out.println("after sent the breakpoint command ");
  
}




public void putBreakPointOnOff() throws IOException
{
   StringBuffer errMsg=null;
   int status = 0;

   // find the line number on which we put breakPoint
   Range prange = new Range(0,length());
   Vector vector = paragraphsForRange(prange);
   int lineNumber = vector.indexOf(currentRange);
   
   //send breakPoint command to HPF server:
   //command tag + lineNumber
   send_command_tag(12,javaGUI.PUTBREAKONOFF,selected_pids);
   slib.send_int(lineNumber+1);//we stars lines at zero: i->i+1//
   System.out.println("after sent the breakpoint command ");
   
}

public void stepOver_ack() throws IOException
{
   // get result from HPF server
   statusInfo status = readAck(javaGUI.STEPOVER);
   if (status.retstatus() < 0)
     return;
  
   int newLineNum =  status.line();

   System.out.println("after getting line :"+newLineNum);
   gotoLine(status); 

  
}

public void stepOver() throws IOException
{
   // send stepOver command to HPF server:
   // tag+STEPOVER 
   send_command_tag(8,javaGUI.STEPOVER,selected_pids);
   
   System.out.println("after sending stepover command");
}

public void stepInto_ack() throws IOException
{
   // get result from HPF server
   statusInfo status = readAck(javaGUI.STEPINTO);
   if (status.retstatus() < 0)
      return;
   int newLineNum =  status.line();
   gotoLine(status);
   System.out.println("after stepInto new line Num :"+newLineNum);


  
}

public void stepInto() throws IOException
{
   // send stepOver command to HPF server:
   // tag+STEPINTO
  send_command_tag(8,javaGUI.STEPINTO,selected_pids);
  System.out.println("after sent stepInto command ");
   
}

public void NStepOver_ack() throws IOException
{
   // get result from HPF server
   statusInfo status = readAck(javaGUI.NSTEPOVER);
   if (status.retstatus() < 0)
     return;

   int newLineNum =  status.line();
   gotoLine(status);
   System.out.println("after stepOver new line Num :"+newLineNum); 

  
}

public void NStepOver(int N) throws IOException
{
   // send stepOver command to HPF server:
   // tag +N
   send_command_tag(12,javaGUI.NSTEPOVER,selected_pids);
   slib.send_int(N); 
   System.out.println("after sent nstepover command");
   
}

public void NStepInto_ack() throws IOException
{
   // get result from HPF server
   statusInfo status = readAck(javaGUI.NSTEPINTO);
   if (status.retstatus() < 0)
     return;
   
   int newLineNum =  status.line();
   gotoLine(status);
   System.out.println("after stepInto new line Num :"+newLineNum);
  
}


public void NStepInto(int N) throws IOException
{
   // send stepInto command to HPF server:
   // tag+N
   send_command_tag(12,javaGUI.NSTEPINTO,selected_pids);
   slib.send_int(N); 
   System.out.println("after sent stepInto command");
}

public void nIteration_ack() throws IOException
{
   // get result from HPF server
   statusInfo status = readAck(javaGUI.NITERATION);
   if (status.retstatus() < 0)
     return;

   int newLineNum =  status.line();
   gotoLine(status);
   System.out.println("after  nIteration new line : "+newLineNum);

  
}



public void nIteration(int N) throws IOException
{
   // send nIteration command to HPF server:
   // tag+N
   send_command_tag(12,javaGUI.NITERATION,selected_pids);
   slib.send_int(N); 

   System.out.println("after  sent nIteration new line : "+N);

}

public void makeContinue_ack() throws IOException
{
   // get result from HPF server
   statusInfo status = readAck(javaGUI.CONTINUE);
   if (status.retstatus() < 0)
     return;
   
   int newLineNum =  status.line();
   gotoLine(status);
   System.out.println("after  makeContinue ");
  
}


public void makeContinue() throws IOException
{
   // send Continue command to HPF server:
   // tag+CONTINUE
   send_command_tag(8,javaGUI.CONTINUE,selected_pids);
  
   System.out.println("after  sent makeContinue ");

}

public static int  packed_string_length(String str) 
{  
      int len,rem;
 
      //packed string will consist of :
      //length of original string(4 bytes) +
      //original string(lengh()) with padded zeros(rem) to make multiple of 4

      len  = str.length(); // original length of string
      rem = 0;
      if ((len%4) != 0)
        rem = 4-len%4;
      len += rem; // pad zeros to make multiple of 4
      
      len = len + 4; // integer representing length of original string
      return len;
}

        
public void displayVariable_ack()throws IOException  
{
   String varValue=null;

   // get result from HPF server
   statusInfo status = readAck(javaGUI.DISPLAY);
   if (status.retstatus() < 0)
      return ;

   // receive real data
   int []tag_type_ndims = new int[16];
   String []avarName = new String[1];
   Object obj = recv_registrated_data(tag_type_ndims,avarName) ;
 
   System.out.println("it is local sure ");
   varValue = StrValOfData(obj);    

   CommandEvent cev = new CommandEvent((Target)manager,"DisplayVar",
             avarName[0]+"  :"+varValue+"\r\n");
   Application.application().eventLoop().addEvent(cev);
   System.out.println("after receiving ack. for displayvar ");
   
}


public void displayVariable()throws IOException
{
   String varName;
   String varValue=null;
   String selectedString = stringForRange(selectedRange());
   // If user has not selected one variable, pop up one dialog window
   // for user to enter variable name
   if ((selectedString == null)||
       ((selectedString != null)&&(selectedString.trim().length() == 0)))
     {
       System.out.println("I am popping up one window for user ");
       readWindow = new readValue(superview(),"Variable Name: ",
                    this,"GetVarName");
       readWindow.show();
       return;
   }
   else
      varName  = selectedString.trim();
  
   // send Display command to HPF server:
   // tag+varName
   int buflen = packed_string_length(varName)+8;
   send_command_tag(buflen,javaGUI.DISPLAY,selected_pids);
   slib.send_String(varName); 
   System.out.println("after sent display command ");
}


public void displayEnteredVariable(Object varNameObject) throws IOException
{
   String varValue=null;
   String varName  = ((TextField)varNameObject).stringValue().trim();
   readWindow.hide();

   // send Display command to HPF server:
   // tag+variableName

   int buflen = packed_string_length(varName)+8;
   send_command_tag(buflen,javaGUI.DISPLAY,selected_pids);
   slib.send_String(varName); 
   System.out.println("after sent display command ");
}


public void  getVarValPair()
{
   String varName;
   String selectedString = stringForRange(selectedRange());
   // If user has not selected one variable, pop up one dialog window
   // for user to enter variable name
   if ((selectedString == null)||
       ((selectedString != null)&&(selectedString.trim().length() == 0)))
     {
       System.out.println("I am popping up one window for user ");
       readWindow = new readValue(superview(),
			"Variable Name: +Its Value: ",
                        this,"GetNameValEnv");
   }
   else{
      varName  = selectedString.trim();
      readWindow = new readValue(superview(),"Value of "+varName+" :",
                  this,"GetVarValue");
   }
   readWindow.show();
}

public void sendFuncCallString(String fCallString)throws IOException
{
  //Send the function attach command first
  slib.send_int(javaGUI.ATTACHFCALL); 

  //and send function call string "java_ser_(....paramas...)
  slib.send_String(fCallString); 

  // find the line number on which we put breakPoint
  Range prange = new Range(0,length());
  Vector vector = paragraphsForRange(prange);
  int lineNumber = vector.indexOf(currentRange);
  //Send the line number on whicg you attach function call
  slib.send_int(lineNumber+1);

  //read acknowledgement
  statusInfo status = readAck(javaGUI.ATTACHFCALL);

}

public String appendB(String s,int len)
{
  String sum = s;
  String init = new String(s);
  for(int k=0;k<(len - init.length());k++){
     sum = sum+" ";
  } 
  return sum;

}

public void store_config_ack()throws IOException 
{
  
   //read acknowledgement
  statusInfo status = readAck(javaGUI.STORE_CONFIG);

}


  
public void store_config(String configFileName) throws IOException 
{
  // send the necessary command and configFilename
  int buflen = packed_string_length(configFileName)+8;
  send_command_tag(buflen,javaGUI.STORE_CONFIG,selected_pids);
  slib.send_String(configFileName);
  
}
   

public void store_module(String configFileName) throws IOException 
{
  // send the necessary command and configFilename
  slib.send_int(javaGUI.STORE_CONFIG);
  slib.send_String(configFileName);
  
  //read acknowledgement
  statusInfo status = readAck(javaGUI.STORE_CONFIG);

  String AppDir = "";
  int li = HTTPFile.lastIndexOf('/');
  if (li >=0)
    AppDir = HTTPFile.substring(0,li+1);
  else 
    {
       li = HTTPFile.lastIndexOf('\\');
       AppDir = HTTPFile.substring(0,li+1);
    }
  
  //Start WebFlow modules dynamically
  String WebFlowCmnd = new String ("http://osprey2.npac.syr.edu:8080/Create?fname=http://"+HTTPHost+":"+HTTPPort+AppDir+configFileName);
  System.out.println("WebFlowCommand : "+WebFlowCmnd);  
  
  try{
        URL WebFlowUrl = new URL(WebFlowCmnd); 
        DataInputStream theHTML = new DataInputStream(WebFlowUrl.openStream());
  }catch (MalformedURLException ev)
   {
       System.out.println("URL error in store_config (run) " + ev);
   } 
  catch (IOException ev) 
   {
       System.out.println("IOException in store_config (run)"+ev); 
   }
  
}

public void getProfileData_ack() throws IOException
{
  int lineNum,tag;  
  String funcName,sum = "";
  int stmtID,nexecution;
  double elapsed_time;
  
  statusInfo status = readAck(javaGUI.GET_PROFILE_DATA);
  int numOfFiles = rlib.recv_int(); 
  for(int k=0;k<numOfFiles;k++){
     tag = rlib.recv_int(); 
     while(tag != (-2)){
        lineNum      = rlib.recv_int(); 
        funcName     = rlib.recv_String().toString(); 
        stmtID       = rlib.recv_int(); 
        nexecution   = rlib.recv_int(); 
        elapsed_time = rlib.recv_double(); 
        sum = sum+appendB(Integer.toString(lineNum),9)+
	         appendB(funcName,35)+
	         appendB(Integer.toString(stmtID),42)+
	         appendB(Integer.toString(nexecution),53)+
	         appendB(new Double(elapsed_time).toString(),0)+"\n";
        tag = rlib.recv_int();
     }
  }
  String []args = new String[1];
  args[0] = sum;
  jswin.call("updateProfileData_ack_sciviz_window",args);
  

}



public void  getProfileData() throws IOException
{
  //Send  command first to get profile data
  int buflen = 8;
  send_command_tag(buflen,javaGUI.GET_PROFILE_DATA,selected_pids);
  System.out.println("After getProfileData ");
  
}

public void  getFunctionParams_ack()throws IOException
{
   int openIndex=0,closeIndex=0,lineNum=0,nthf=0;
   String [] outs  = new String[0];

   //read acknowledgement
   statusInfo status = readAck(javaGUI.GET_FUNCTION);
   if (status.retstatus() < 0)
     return ;
   
   String funcName = rlib.recv_String().toString(); 
   int nparams     = rlib.recv_int(); 
   outs  = new String[nparams+1];
   outs[0] = funcName;  
   System.out.println("I got nparams: "+nparams+" fname :"+outs[0]);
   for(int i=1;i<nparams+1;i++){
     outs[i] = rlib.recv_String().toString(); 
     System.out.println("outs[i] : "+outs[i]);
   } 
   Object []jsargs = new Object[1];
   jsargs[0] = outs;
   jswin.call("choseFunction_ack_sciviz_window",jsargs);
   
    
}


public void getFunctionParams(String lineNumStr)throws IOException
{
   int openIndex=0,closeIndex=0,lineNum=0,nthf=0;
   String [] outs  = new String[0];

   openIndex = lineNumStr.indexOf('(',0);
   if (openIndex < 0)
     lineNum = Integer.parseInt(lineNumStr);
   else{
     lineNum = Integer.parseInt(lineNumStr.substring(0,openIndex));
     closeIndex = lineNumStr.indexOf(')',0);
     nthf = Integer.parseInt(lineNumStr.substring(openIndex+1,closeIndex));
   }

    //Send Command to get function name&its parameters
   int buflen = 8;
   if (openIndex <0)
     buflen += 4;
   else
     buflen += 12;
   send_command_tag(buflen,javaGUI.GET_FUNCTION,selected_pids);

   if (openIndex <0)
     slib.send_int(lineNum);
   else{
     slib.send_int(-1);
     slib.send_int(lineNum);
     slib.send_int(nthf);
   }

}

public void add_action_ack()  throws IOException
{
  
  //read acknowledgement
  statusInfo status = readAck(javaGUI.ADD_ACTION);
  
  if (status.retstatus() == 0){
      int lineNumber = status.line();
      Rect action_rect  = (Rect)(textLineRects[lineNumber-1].elementAt(0));
 
      int findex = fileNames.indexOf(currentFileName);  
      if (!actionPoints.contains(action_rect)){
         actionPoints.addElement(action_rect);
	 actionFileIndex.addElement(new Integer(findex));
      }
      draw();
  }
  
}

public void delete_action_ack()  throws IOException
{
  
  //read acknowledgement
  statusInfo status = readAck(javaGUI.DELETE_ACTION);
  
  if (status.retstatus() == 0){
      int lineNumber = status.line();
      Rect action_rect  = (Rect)(textLineRects[lineNumber-1].elementAt(0));
      
      int actionIndex = actionPoints.indexOf(action_rect);
      System.out.println("DELETE_ACTION: lineNumber: "+lineNumber+" REct "+
			 action_rect+"actionIndex "+actionIndex+
			 " size ofactionFileIndex :"+actionFileIndex.size());
      actionPoints.removeElement(action_rect);   
      actionFileIndex.removeElementAt(actionIndex);
      draw();
  }
  
}

public void JSsendFcall(String fCallString,int opt,String slineNumber)
     throws IOException
{
  int lineNumber=0;

  int buflen = packed_string_length(fCallString)+12;
  //get the linenumber at which user puts action
  if (slineNumber.equalsIgnoreCase("all"))
    lineNumber = -1;
  else
    lineNumber = Integer.parseInt(slineNumber);  
  
  //Send the function attach command first
  if (opt == 1){
     send_command_tag(buflen,javaGUI.ADD_ACTION,selected_pids);
     System.out.println("add_action :"+lineNumber+" fcal  "+fCallString);
   }   
   else if (opt == 2){
     send_command_tag(buflen,javaGUI.DELETE_ACTION,selected_pids);
     System.out.println("delete_action :"+lineNumber+" fcal  "+fCallString);
   }

  //and send function call string "java_ser_(....paramas...)
  slib.send_String(fCallString); 
  //Send the line number on which you attach function call
  slib.send_int(lineNumber);

}

public void applyConfig(String configFile) throws IOException
{
   
   //send command
   int buflen = packed_string_length(configFile)+8;
   send_command_tag(buflen,javaGUI.APPLY_CONFIG,selected_pids);
   // send config file name
   slib.send_String(configFile); 
}

public void applyConfig_ack() throws IOException
{
   //read acknowledgement
   statusInfo status = readAck(javaGUI.APPLY_CONFIG);
  
   //Attach action points
   int nactions = rlib.recv_int();
   for(int n=0;n<nactions;n++){
     int lineNumber = rlib.recv_int();
     String fileName = rlib.recv_String().toString();

     System.out.println("file_action : "+fileName);

     Rect action_rect  = (Rect)(textLineRects[lineNumber-1].elementAt(0));
     int findex = fileNames.indexOf(fileName);  
     if (findex < 0){
       System.out.println("Action:I am adding new file "+fileName);
       
       findex = fileNames.size();
       fileNames.addElement(fileName);
       fileNames.addElement(new Integer(-1));
       fileNames.addElement(new Integer(-1));
     }
     
     if (!actionPoints.contains(action_rect)){
       System.out.println("Action:Attaching action to "+lineNumber);
       
       actionPoints.addElement(action_rect);
       actionFileIndex.addElement(new Integer(findex));
     }
   }

   //Attach break points
   int nbreaks = rlib.recv_int();
   for(int n=0;n<nbreaks;n++){
     int lineNumber = rlib.recv_int();
     String fileName = rlib.recv_String().toString();

     System.out.println("file_break : "+fileName);

     Rect break_rect  = (Rect)(textLineRects[lineNumber-1].elementAt(0));
     int findex = fileNames.indexOf(fileName);  
     if (findex < 0){
       System.out.println("Break:I am adding new file "+fileName);
       findex = fileNames.size();
       fileNames.addElement(fileName);
       fileNames.addElement(new Integer(-1));
       fileNames.addElement(new Integer(-1));
     }
     
     if (!breakPoints.contains(break_rect)){
       System.out.println("Break:Attaching break to "+lineNumber);
       breakPoints.addElement(break_rect);
       breakFileIndex.addElement(new Integer(findex));
     }
     else{
       System.out.println("Break:Removing break to "+lineNumber);
       int breakIndex = breakPoints.indexOf(break_rect);
       breakPoints.removeElement(break_rect);
       breakFileIndex.removeElementAt(breakIndex);
     }
   }
   
   draw();
}

public void  recvConfigFiles_ack() throws IOException
{
   statusInfo status = readAck(javaGUI.SEND_CONFIGS);
   int cnt = rlib.recv_int();  
   String outs[] = new String[cnt];
  
   for(int i=0;i<cnt;i++){
    outs[i] = rlib.recv_String().toString(); 
    System.out.println("received config "+outs[i]);
   }
  
   Object []jsargs = new Object[1];
   jsargs[0] = outs;
   jswin.call("getConfigFiles_ack_sciviz_window",jsargs);
      
}



public void  recvConfigFiles() throws IOException
{
  int buflen = 8;
  send_command_tag(buflen,javaGUI.SEND_CONFIGS,selected_pids);
}

public void  setVariable_ack()throws IOException
{
    // get result from HPF server
   statusInfo status = readAck(javaGUI.SETVARIABLE);
   if (status.retstatus() < 0)
      return ;
   
   //receive type of the variable whose value we will send to set parameter
   int type = rlib.recv_int();
   //receive id of variabel in registration table
   int id = rlib.recv_int();

   //send varvalue command
   int buflen = 12+primitive_length(type); //send id + variable value
   send_command_tag(buflen,javaGUI.VARVALUE,selected_pids);
   slib.send_int(id);
   send_primitive_var(type,setvar_NameValue);
   System.out.println("after getting ack. for setvariable and sent varvalue");
   
}

public int primitive_length(int type) 
{
  int len=0;

  switch(type){
  case javaGUI.T_INT: len = 4;break;
  case javaGUI.T_DOUBLE: len = 8;break;
  case javaGUI.T_BYTE:   len=1;break;
  case javaGUI.T_SHORT:  len=2;break;
  case javaGUI.T_FLOAT:  len=4;break;
  case javaGUI.T_CHAR:   len=1;break;
  case javaGUI.T_LONG:   len=8;break;
 }
 return len;

}

public void setVariable(String input)throws IOException
{
   String varName, varValue;

   int i = input.indexOf(' ');
   varName  = input.substring(0,i);
   varValue = input.substring(i+1);

   // send Setvar command to HPF server:
   // SETVARIABLE + variableName
   int buflen = packed_string_length(varName)+8;
   send_command_tag(buflen,javaGUI.SETVARIABLE,selected_pids);
   slib.send_String(varName); 
   System.out.println("after sent setvariable command varname : "+varName+
                  "  value: "+varValue);
   // store value of variabler for VarVALUE command to use them
   setvar_NameValue = varValue;
   
   System.out.println("After sent setvariable command ");
   

}

public void setEnteredVariable(String labelText)throws IOException
{

   int index = labelText.indexOf('+');
   String varName = labelText.substring(0,index);
   String varValue = labelText.substring(index+1);
   System.out.println("VarName : "+varName +" varValue :"+varValue);
  
   // send Setvar command to HPF server:
   // SETVARIABLE + variableName
   int buflen = packed_string_length(varName)+8;
   send_command_tag(buflen,javaGUI.SETVARIABLE,selected_pids);
   slib.send_String(varName); 
   //store value of variable  for VarVALUE command to use them
   setvar_NameValue = varValue;
   System.out.println("after sent setvariable command varname : "+varName+
                  "  value: "+varValue);

}

public void send_primitive_var(int type,String varValue) throws IOException
{
  switch(type){
  case javaGUI.T_INT: 
  {
     int val = Integer.parseInt(varValue);
     slib.send_int(val);
  }
  break;
  case javaGUI.T_DOUBLE:
    {
      double val = Double.valueOf(varValue).doubleValue();
      slib.send_double(val);
    }
  break;
  case javaGUI.T_BYTE:
    {
      byte val = Byte.parseByte(varValue);
      slib.send_byte(val);
    }
  break;
  case javaGUI.T_SHORT:
    {
      short val = Short.parseShort(varValue);
      slib.send_short(val);
    }
  break;
  case javaGUI.T_FLOAT:
    {
      float val = Float.valueOf(varValue).floatValue() ;
      slib.send_float(val);
    }
  break;
  case javaGUI.T_CHAR:
    {
      char val = varValue.charAt(0);
      slib.send_char(val);
    }
  break;
  case javaGUI.T_LONG:
    {
      long val = Long.parseLong(varValue);
      slib.send_long(val);
    }
  }
}

public void goToCursor_ack() throws IOException
{
   int lineNumber = -1;
    // get result from HPF server
   statusInfo status = readAck(javaGUI.GOTOCURSOR);
   if (status.retstatus() < 0)
     return;

   // get the line number. This is  not necessary but for completeness
   if(status.retstatus() == 0){
     lineNumber = status.line();
     gotoLine(status);
   }
   System.out.println("after gotoCursor new line Num :"+lineNumber);
   
}


public void goToCursor() throws IOException
{
   
   //find the line number on which we are going to go

   Range prange = new Range(0,length());
   Vector vector = paragraphsForRange(prange);
   int lineNumber = vector.indexOf(currentRange);

   //send stepOver command to HPF server:
   //GOTOCURSOR +N
   int buflen = 12;
   send_command_tag(buflen,javaGUI.GOTOCURSOR,selected_pids);
   slib.send_int(lineNumber+1); 

   System.out.println("gotocursor to :"+lineNumber+1);
}

public void makeMoveUp() throws IOException
{

  //send MoveUp command to HPF server
  //GOTOSTACKUP
  int buflen = 8;
  send_command_tag(buflen,javaGUI.GOTOSTACKUP,selected_pids);
  System.out.println("stack Move UP to ");
}

public void makeMoveUp_ack() throws IOException
{

   int lineNumber=0;
  
   // get result from HPF server
   statusInfo status = readAck(javaGUI.GOTOSTACKUP);
   if (status.retstatus() < 0)
     return;

   // get the line number. This is  not necessary but for completeness
   if(status.retstatus() == 0){
     lineNumber = status.line();
     gotoLine(status);
   }
   System.out.println("after statck Move Up new line Num :"+lineNumber);

}


public void makeMoveDown() throws IOException
{
  //send MoveUp command to HPF server
  //GOTOSTACKDOWN
  int buflen = 8;
  send_command_tag(buflen,javaGUI.GOTOSTACKDOWN,selected_pids);
  System.out.println("stack Move DOWN to ");
}
   
public void makeMoveDown_ack() throws IOException
{
   int lineNumber=0;
   // get result from HPF server
   statusInfo status = readAck(javaGUI.GOTOSTACKDOWN);
   if (status.retstatus() < 0)
     return;

   // get the line number. This is  not necessary but for completeness
   if(status.retstatus() == 0){
     lineNumber = status.line();
     gotoLine(status);
   }
   System.out.println("after statck Move DOWN new line Num :"+lineNumber);

}


public void getSciVisFlist_ack() throws IOException
{
   statusInfo status = readAck(javaGUI.SCIVIS_FUNCTION_LIST);
   if (status.retstatus() < 0)
     return;

   //get result from HPF server
   int nfuncs = rlib.recv_int(); 
   String [] outs = new String[nfuncs];
   for(int i=0;i<nfuncs;i++)
     outs[i] = rlib.recv_String().toString();

   Object []jsargs = new Object[1];
   jsargs[0] = outs;
   jswin.call("send_flist_request_ack_sciviz_window",jsargs);
   
}

public void getSciVisFlist() throws IOException
{
  // Send the command for getting all the scivis functions and timer ones
  int buflen = 8;
  send_command_tag(buflen,javaGUI.SCIVIS_FUNCTION_LIST,selected_pids);
}

public void  getLocalVars_ack() throws IOException
{
   statusInfo status = readAck(javaGUI.SEND_LOCALS);
   int nlocals = rlib.recv_int(); 
   String [] outs = new String[nlocals];
   for(int i=0;i<nlocals;i++)
     outs[i] = rlib.recv_String().toString();

   Object []jsargs = new Object[1];
   jsargs[0] = outs;
   jswin.call("updateLocalVars_sciviz_window",jsargs);
                          
}


public void getLocalVars() throws IOException
{
   // Send the command for getting all local variabels
  int buflen = 8;
  send_command_tag(buflen,javaGUI.SEND_LOCALS,selected_pids);
}

public void  getActionPoints_ack() throws IOException
{
   Vector points = new Vector();
   int nextnum,npairs;
   int []point_list;
   Integer ival;

    // get ack.
   statusInfo status = readAck(javaGUI.ACTION_LIST); 
   if (status.retstatus() < 0)
     return;
   
   //get result from HPF server
   nextnum = rlib.recv_int(); 
   while(nextnum != -2){
     if (nextnum == -1){
       nextnum = rlib.recv_int(); 
       npairs  = rlib.recv_int(); 
       points.addElement(new Integer(-1));
       points.addElement(new Integer(nextnum));
       points.addElement(new Integer(npairs));
     }
     else
       points.addElement(new Integer(nextnum)); 
     nextnum = rlib.recv_int(); 
   }

   int vsize = points.size();
   point_list = new int[vsize];
   for(int i=0;i<vsize;i++){
     ival = (Integer)(points.elementAt(i));
     point_list[i] = ival.intValue();
   }
   
   Object []jsargs = new Object[1];
   jsargs[0] = point_list;
   jswin.call("recvActionPoints_ack_sciviz_window",jsargs);
}

public void getActionPoints() throws IOException
{

   // Send the command for getting all action points
   int buflen = 8;
   send_command_tag(buflen,javaGUI.ACTION_LIST,selected_pids);

}

public void gotoLine(statusInfo status) throws IOException
{
   Rect rect,visrect;

   int newLine = status.line()-1;
   
   //check abnormal program termination
   if (newLine+1 == javaGUI.ABNORMALTERM){
      StringBuffer sb = rlib.recv_String();
      CommandEvent cev = new CommandEvent((Target)manager,"Display",sb);
      Application.application().eventLoop().addEvent(cev);
      stopAndKillApplication();
      return;
   }

   // check program termination
   if (newLine+1 == javaGUI.STOPPROGRAM ){
       stopAndKillApplication();
       return;
   }

   System.out.println("Before gotoLine pc: ");
   if (newLine+1 == javaGUI.GETNEWFILE){
     System.out.println("I am receiving new file... ");
     String newFileName   = status.receivedAck();
     setTextViewContent(HTTPHost,HTTPPort,newFileName);
     newLine = status.retstatus()-1;
     
   }

   Vector item = textLineRects[newLine];
   rect = (Rect)(item.elementAt(0));
   pc = rect;
   System.out.println("I am moving to  :"+newLine+" pc: "+pc+
       "size : "+textLineRects.length+" rect:"+rect);

   visrect = new Rect();
   computeVisibleRect(visrect);

   if ((pc.y+pc.height > visrect.y+visrect.height)&&
       (!containsPointInVisibleRect(pc.x,pc.y+2*(pc.height)))){
         rect = new Rect(pc.x,pc.y,visrect.width,visrect.height);
         scrollRectToVisible(rect);
    }
    else if (!containsPointInVisibleRect(pc.x,pc.y-pc.height)) 
    {
      rect = new Rect(pc.x,pc.y,visrect.width,visrect.height);
      scrollRectToVisible(rect);
    }
 
   if (currentLineNumber != newLine){
      currentLineNumber = newLine;
      draw();
    }
    
}


public void setPreferences(View window)
{
    TextField field;
  
    Vector fields = window.subviews();
    int    n      = fields.size();

    field = (TextField)(fields.elementAt(1));
    ManagerServerPort = field.stringValue();

    field = (TextField)(fields.elementAt(3));
    SciVisHost = field.stringValue();

    field = (TextField)(fields.elementAt(5));
    SciVisPort = field.stringValue();

    field = (TextField)(fields.elementAt(7));
    SageServerHost = field.stringValue();
    
    field = (TextField)(fields.elementAt(9));
    SageServerPort = field.stringValue();

    field = (TextField)(fields.elementAt(11));
    applicationType = field.stringValue();

    field = (TextField)(fields.elementAt(13));
    numOfProcs = field.stringValue();
    //create necessary space to keep the interested pids
    selected_pids = new int[new Integer(numOfProcs).intValue()];

    field = (TextField)(fields.elementAt(15));
    HPFSOURCEDIR = field.stringValue();

    field = (TextField)(fields.elementAt(17));
    CGIBINDIR = field.stringValue();
    
}



public InternalWindow getPreferences()
  {
    InternalWindow window;
    TextField field,label;
    Button button;
        
    window = new InternalWindow(0, 0, 400, 400);
    window.setResizable(true);
    window.setTitle("Preferences");
    window.setCloseable(true);
    window.contentView().setColor(Color.lightGray);

    GridLayout glayout = new GridLayout(10,2);
    window.contentView().setLayoutManager(glayout);

    label = TextField.createLabel("Manager Server Port:");
    field = new TextField(1,1,1,1);
    field.setStringValue(ManagerServerPort);
    window.addSubview(label);
    window.addSubview(field);
       
    label = TextField.createLabel("Scivis Host :");
    field = new TextField(1,1,1,1);
    field.setStringValue(SciVisHost);
    window.addSubview(label);
    window.addSubview(field);
    
    label = TextField.createLabel("Scivis Port :");
    field = new TextField(1,1,1,1);
    field.setStringValue(SciVisPort);
    window.addSubview(label);
    window.addSubview(field);

    label = TextField.createLabel("Sage Server Host :");
    field = new TextField(1,1,1,1);
    field.setStringValue(SageServerHost);
    window.addSubview(label);
    window.addSubview(field);
    
    label = TextField.createLabel("Sage Server Port :");
    field = new TextField(1,1,1,1);
    field.setStringValue(SageServerPort);
    window.addSubview(label);
    window.addSubview(field);


    label = TextField.createLabel("SIMD/MIMD(1/2) :");
    field = new TextField(1,1,1,1);
    field.setStringValue(applicationType);
    window.addSubview(label);
    window.addSubview(field);
    
    label = TextField.createLabel("Number of Processors :");
    field = new TextField(1,1,1,1);
    field.setStringValue(numOfProcs);
    window.addSubview(label);
    window.addSubview(field);

    
    label = TextField.createLabel("HPF Source Directory :");
    field = new TextField(1,1,1,1);
    field.setStringValue(HPFSOURCEDIR);
    window.addSubview(label);
    window.addSubview(field);
    
    label = TextField.createLabel("Cgi-Bin Directory :");
    field = new TextField(1,1,1,1);
    field.setStringValue(CGIBINDIR);
    window.addSubview(label);
    window.addSubview(field);

    button = new Button(1,1,1,1);
    button.setTitle("Ok");
    button.setTarget(this);
    button.setCommand("AcceptPref");
    window.addSubview(button);

    button = new Button(1,1,1,1);
    button.setTitle("Cancel");
    button.setTarget(this);
    button.setCommand("CancelPref");
    window.addSubview(button);
    
    window.contentView().layoutView(0,0);
    window.show();

    return window;
    
  }
  

public void send_jswindow_command_tag(int subcommand,int buflen)
  throws IOException
{
   slib.send_int(javaGUI.JSWINDOW);
   slib.send_int(buflen);
   slib.send_int(subcommand);
        
}


public void update_jswindow() throws IOException
{
   int subcommand;
   subcommand = rlib.recv_int();
   System.out.println("JSWINDOW:subcommand:"+subcommand);
   
   switch(subcommand)
   {
     //open project window
     case javaGUI.OPENPROJWIN: 
       jswin.eval("open_project_window()");
       break;
       //open sciviz window  
     case javaGUI.OPENSCIVIZWIN:   
       jswin.eval("open_sciviz_window()");
       break;
       //open interpreter window  
     case javaGUI.OPENINTERPWIN:
      jswin.eval("open_interpreter_window()");
      break;
      
       
   }
   


  
}


public void performCommand(String command, Object anObject) 
{
     String varName=null;
       
      System.out.println("new command  "+command);
 
      if (command.equals("Pause")){
	try{
	  sendPauseCommand();
	}catch(IOException ev){
           System.out.println("IOException in performCommand(Pause)"+ev);
          }
      }

      else if (command.equals("MoveDown")){
	try{
	  makeMoveDown();
	}catch(IOException ev){
           System.out.println("OException in performCommand(makeMoveDown)"+ev);
          }
      }
      else if (command.equals("MoveUp")){
	try{
	  makeMoveUp();
	}catch(IOException ev){
           System.out.println("OException in performCommand(makeMoveUp)"+ev);
          }
      }
      
     else if (command.equals("Stop")){
       try{
         stopAndKillApplication();
       }catch(IOException ev){
           System.out.println(" IOException in performCommand(Stop) "+ev);
          }
     }

     else if (command.equals("Break")) {
         RoundedButton rb = (RoundedButton)anObject;
	if (rb.lastEvent.isShiftKeyDown()){
             readWindow = new readValue(superview(),"Line Number :",
                    this,"GetBreakNumber");
             readWindow.show();
         }
         else{ 
	   try{ 
	     putBreakPointOnOff();
	   }catch(IOException ev){
	     System.out.println(" IOException in performCommand(Break) "+ev);
	   }
	 }
         //close icon window for breakPoint
         rb.closeLabelWin();
      }
      else if (command.equals("GetBreakNumber")){
         String s = ((TextField)anObject).stringValue();
	 int    N = Integer.parseInt(s);
         readWindow.hide();
         try{
            putBreakPointOnOff(N);
         }catch(IOException ev){
	   System.out.println("Exception in GetBreakNumber "+ev);}
      }
      
      else if (command.equals("StepOver")) {
         RoundedButton rb = (RoundedButton)anObject;  
         if (rb.lastEvent.isShiftKeyDown()){
             readWindow = new readValue(superview(),"Number of Lines :",
                    this,"GetSOverNumber");
             readWindow.show();
         }
         else{    
            try{ 
             stepOver();
           }catch(IOException ev){
            System.out.println(" IOException in performCommand(StepOver) "+ev);
           }
	 }
         rb.closeLabelWin();
      }

      else if (command.equals("StepInto")) {
         RoundedButton rb = (RoundedButton)anObject;  
         if (rb.lastEvent.isShiftKeyDown()){
             readWindow = new readValue(superview(),"Number of Lines :",
                    this,"GetSIntoNumber");
             readWindow.show();
         }
         else {
           try{ 
             stepInto();
           }catch(IOException ev){
            System.out.println(" IOException in performCommand(StepInto) "+ev);
           }
	 }
         rb.closeLabelWin();
      }
      
      else if (command.equals("GetFile")){
	jswin.eval("open_project_window()");

        //bcast the opening of this project window to other clients
	try{ 
	  send_jswindow_command_tag(javaGUI.OPENPROJWIN,4);
	}catch(IOException ev){
            System.out.println(" IOException in performCommand(getfile) "+ev);
           }  
	//user can not start his application without chosing project
        //manager.runButton.setEnabled(false);  
      }

      else if (command.equals("GetHPFSource")){
         String projName = (String)anObject;
         currentProjectName = projName;
         System.out.println("I got project name  :"+currentProjectName); 
         HPFFileName = getMainFileName(projName);
         setTextViewContent(HTTPHost,HTTPPort,HPFFileName);
	 // now he can start application
	 manager.runButton.setEnabled(true);
      }
 
      else if (command.equals("UpdateHPFSource")){
         String projName = (String)anObject;
         currentProjectName = projName;
         System.out.println("I got project name  :"+currentProjectName); 
         HPFFileName = getMainFileName(projName);
         UpdateTextViewContent(HTTPHost,HTTPPort,HPFFileName);
	 // now he can start application
	 manager.runButton.setEnabled(true);
      } 

      else if (command.equals("NIteration")) {
         RoundedButton rb = (RoundedButton)anObject;  
         readWindow = new readValue(superview(),"Number of Iterations :",
                    this,"GetNumOfIterations");
         readWindow.show();
      }
       
     else if (command.equals("GetNumOfIterations")){
        String s = ((TextField)anObject).stringValue();
        int    N = Integer.parseInt(s);
        readWindow.hide();
        try{
           nIteration(N);
         }catch(IOException ev){
	    System.out.println("Exception in NIteration"+ev);}
     }
     else if (command.equals("GetSIntoNumber")){
         String s = ((TextField)anObject).stringValue();
	 int    N = Integer.parseInt(s);
         readWindow.hide();
         try{
           NStepInto(N);
         }catch(IOException ev){
	    System.out.println("Exception in NStepInto "+ev);}
     }
    
      else if (command.equals("GetSOverNumber")){
         String s = ((TextField)anObject).stringValue();
	 int    N = Integer.parseInt(s);
         readWindow.hide();
         try{
           NStepOver(N);
         }catch(IOException ev){
	    System.out.println("Exception in NStepOver "+ev);}
     }

     else if (command.equals("GoToCursor")){
        try{ 
             goToCursor();
           }catch(IOException ev){
            System.out.println("IOException in performCommand(GoToCursor)"+ev);
           }
     } 

     else if (command.equals("Display")) {

         RoundedButton rb = (RoundedButton)anObject;  
         if (rb.lastEvent.isShiftKeyDown()){
             readWindow = new readValue(superview(),"Array Expression: ",
                    this,"GetArrayExp");
             readWindow.show();
         }
         else {
           try{ 
             displayVariable();
           }catch(IOException ev){
            System.out.println(" IOException in performCommand(Display) "+ev);
           }
	 }
         rb.closeLabelWin(); 
     }

     else if (command.equals("GetVarName"))
     {
       try{
         displayEnteredVariable(anObject);
       }catch(IOException ev){
        System.out.println("IOException in performCommand(EnteredDisplay)"+ev);
       } 
     }
     else if (command.equals("GetArrayExp")){
         String s = ((TextField)anObject).stringValue();
         readWindow.hide();
         try{
           getArraySection(s);
         }catch(IOException ev){
	    System.out.println("Exception in NStepOver "+ev);}
     }



     else if (command.equals("Continue")){
          try{ 
             makeContinue();
           }catch(IOException ev){
          System.out.println("IOException in performCommand(makeContinue)"+ev);
           }
     } 
     else if (command.equals("Setvar")) {
         RoundedButton rb = (RoundedButton)anObject; 
	 if (rb.lastEvent.isShiftKeyDown()){
	   readWindow = new readValue(superview(),"Enter Function Call :",
                  this,"GetFunctionCall"); 
	   readWindow.show();
	 }
         else{
	   getVarValPair();
	 }
	 
     }
     else if (command.equals("GetNameValEnv")){
        String s = (String)anObject;
        readWindow.hide(); 
        try{ 
            setEnteredVariable(s);
	}catch(IOException ev){
         System.out.println("IOException in performCommand(GetNameValEnv)"+ev);
        }
     }
     else if (command.equals("GetVarValue")) {
         String sval = (String)anObject;
         readWindow.hide();
         try{ 
             setVariable(sval);
           }catch(IOException ev){
           System.out.println(" IOException in performCommand(Setvar) "+ev);
	   }
     }
     else if (command.equals("GetFunctionCall")){
         String s = ((TextField)anObject).stringValue();
	 readWindow.hide();
	 try{
	   sendFuncCallString(s);
	 }catch(IOException ev){
	   System.out.println("IOException in performCommand(GetFunctionCall)"
                 +ev);
	  }
     }
		
      else if (command.equals("Run")){
	try{
	  startHPFApplication();
	}catch(IOException ev){
        System.out.println("IOException in performCommand(startHPFApplication)"        +ev);
	}
	
      }
      
     // handle CONNECT requests
    else if (command.equals("Connect")){
         RoundedButton rb = (RoundedButton)anObject;  
         if (rb.lastEvent.isShiftKeyDown()){
             readWindow = new readValue(superview(),
			"SciVis Host Name: +SciVis Port Number:",
                        this,"GetVisServEnv");
             readWindow.show();
         }
         else {
	  try{
            connectToManagerServer();
   	  }catch(IOException ev){
	    System.out.println("Exception in connectToManagerServer() "+ev);} 

	 }
    }
     else if (command.equals("GetVisServEnv")){
         String s = (String)anObject;
         readWindow.hide(); 
         sendSciVisEnv(s);
     }
    else if (command.equals("SciViz")){
      jswin.eval("open_sciviz_window()");
      try{
	 //bcast the opening of this sciviz window to other clients
	send_jswindow_command_tag(javaGUI.OPENSCIVIZWIN,4);
      }catch(IOException ev){
            System.out.println(" IOException in performCommand(sciviz) "+ev);
           }  
    }
   
    else if (command.equals("Interpreter")){
      jswin.eval("open_interpreter_window()");
      //bcast the opening of this interpreter window to other clients

      try{
	send_jswindow_command_tag(javaGUI.OPENINTERPWIN,4);
	}catch(IOException ev){
            System.out.println(" IOException in performCommand(interpreter) "+ev);
           }  
    }
    else if (command.equals("Ports")){
      PreferenceWindow = getPreferences();
      System.out.println("Preference menu CALLED ..");
    }
    else if (command.equals("AcceptPref")){
      setPreferences(PreferenceWindow.contentView());
      PreferenceWindow.hide();
    }
    else if (command.equals("CancelPref")){
       PreferenceWindow.hide();
    }   
    else if ( command.equals("StartManager")){
       startManager();
      
    }
      
          
  }

public void sendSciVisEnv_ack() throws IOException
{
  statusInfo status = readAck(javaGUI.SCIVISENV);
}


public void sendSciVisEnv(String labelText )
{

    int index = labelText.indexOf('+');
    String SciVisHost = labelText.substring(0,index);
    String SciVisPort = labelText.substring(index+1);
    System.out.println("SciVisHost : "+SciVisHost +" SciVisPort :"+SciVisPort);
    
    try{ 
      slib.send_int(javaGUI.SCIVISENV);
      slib.send_String(SciVisHost);
      slib.send_String(SciVisPort);
      statusInfo status = readAck(javaGUI.SCIVISENV);
    }catch (IOException e) {
          System.out.println("IO Exception in sendSciVisenv"); }
    
}

public void sendEvent(String eventValue)
{
   System.out.println("coming event "+eventValue);
   CommandEvent cev = new CommandEvent((Target)this,"UpdateHPFSource",
           eventValue);
   //CommandEvent cev = new CommandEvent((Target)this,"GetHPFSource",
   //        eventValue);
   Application.application().eventLoop().addEvent(cev);
}

public String  getMainFileName(String projectName)
{
     URL url_file=null;
     projectName += ".prj";
     String cmnd = CGIBINDIR+"sendmain.pl"+"?"+projectName;
     String last=null; 

     try
      {
        String s;
	url_file = new URL("http",HTTPHost,HTTPPort,cmnd);
        System.out.println("cmnd :+ "+url_file.toString());
	// Disable cache
	url_file.openConnection().setUseCaches(false);
        DataInputStream theHTML = new DataInputStream(url_file.openStream());
        while((s = theHTML.readLine())!=null)
           last = s;

      }catch (MalformedURLException ev)
       {
         System.out.println("URL error in getMainFileName " + ev);
       } 
      catch (IOException e) {
            System.err.println("IO Exception in getMainFileName :"+e);
      }
      HPFApplication = "demo_"+projectName.substring(
				     0,projectName.indexOf((int)'.'));
      System.err.println("project :"+projectName);
      return last;
      
}

public void stopAndKillApplication_()
{

    URL url_file=null;
    
    String cmnd = CGIBINDIR+"kill.pl"+"?"+HPFApplication+"+"+SageServerHost;

     try
      {
        String thisLine;
	url_file = new URL("http",HTTPHost,HTTPPort,cmnd);
        DataInputStream theHTML = new DataInputStream(url_file.openStream());
      }catch (MalformedURLException ev)
       {
         System.out.println("URL error in stopAndKillApplication  " + ev);
       } 
     catch (IOException e) {
      System.err.println(e);
     }
}

public void stopAndKillApplication_ack() throws IOException
{
  //statusInfo status = readAck(javaGUI.STOP);
      
   System.out.println("I am stopping my applet !!!");
   
   pc.x = 0;    
   pc.y = 0;
   pc.width  = 0; 
   pc.height = 0;
   breakPoints.removeAllElements();
   actionPoints.removeAllElements();
   draw(); 

   System.out.println("After removing breakpoints and actionpoints ");
   managerCon.close_connection();
   System.out.println("Closing connection to Manager ");
   DaemonThread.stop();
   
   //managerServerThread.stop();
}


public void stopAndKillApplication() throws IOException
{  

   // send Stop command to HPF server:
   // Send the command for getting all local variabels
   int buflen = 8;
   send_command_tag(buflen,javaGUI.STOP,selected_pids);
   System.out.println("I sent STOP command to manager !!");

}

public void startProg(String protocol,String host,int port,String command)
throws IOException
{
  
  URL url_file;
  DataInputStream theHTML = null;
     
      try
      {
        String thisLine;
	url_file = new URL(protocol,host,port,command);
        theHTML = new DataInputStream(url_file.openStream());
      }catch (MalformedURLException ev)
	{
          System.out.println("URL error in HPFServerThread (run) " + ev);
	} 
      catch (IOException ev) 
	{
          System.out.println("IOException in HPFServerThread (run)"+ev); 
        }

     String s = theHTML.readLine();
  
}

public void startManager() 
{
  
    URL url_file=null;
    String s=null;
    BufferedReader dos=null;
    URLConnection opc=null;
    String cmnd = CGIBINDIR+"startManager.pl"+"?"+ManagerServerPort;
         
    System.out.println("I am starting Manager : "+cmnd);
    managerServerThread = new HPFServerThread("http",HTTPHost,HTTPPort,cmnd);
    managerServerThread.start();
 
} 


public void startHPFApplication_cgibin() 
{
  
    URL url_file=null;
    String s=null;
    BufferedReader dos=null;
    URLConnection opc=null;
    //String cmnd = CGIBINDIR+"runHPF.pl"+"?"+HPFApplication+"+"
    //      +HPFServerPort+"+"+SageServerHost+"+"+SageServerPort+"+"
    //      +SciVisHost+"+"+SciVisPort+"+"+numOfProcs+"+"+applicationType;
 
    //System.out.println("I am starting app.: "+cmnd);
   
    //managerServerThread = new HPFServerThread("http",HTTPHost,HTTPPort,cmnd);
    //managerServerThread.start();
 
} 

public void send_administration_command_tag(int subcommand)
     throws IOException
{
   slib.send_int(javaGUI.ADMIN);
   slib.send_int(subcommand);
}
  
public void startHPFApplication() throws IOException 
{
  
    send_administration_command_tag(javaGUI.START);

    //send parameters to start application
    //String script = CGIBINDIR+"runHPF.pl";
    String script = "runHPF.pl";
    slib.send_String(script);
    slib.send_String(HPFApplication);
    slib.send_String(ManagerServerPort);
    slib.send_String(SageServerHost);
    slib.send_String(SageServerPort);
    slib.send_String(SciVisHost);
    slib.send_String(SciVisPort);
    slib.send_String(numOfProcs);
    slib.send_String(applicationType);

}  

public void connectToManagerServer() throws IOException
{
 
     boolean done = false;
     int ManagerServerPort_int = new Integer(ManagerServerPort).intValue();
     
     while(!done)
     {
        try {
          managerCon = new connection(HTTPHost,ManagerServerPort_int,true);
          done = true;
        }
        catch (IOException e) {
          System.out.println("IO Exception CMatrix");
          done = false;
        }   
     }

     System.out.println("I connected to Manager Server ");
     
     rlib   = new recv_module(managerCon);
     slib   = new send_module(managerCon);

     //register to manager as applet
     slib.send_int(javaGUI.REGISTER_CLIENT);
     slib.send_int(javaGUI.APPLET);
     System.out.println("I registered to manager as applet ");
     
     setTextViewContent(HTTPHost,HTTPPort,HPFFileName);

     //start applet deamon////////////////////////
     DaemonThread = new appletDaemon(this);
     DaemonThread.setPriority(Thread.MAX_PRIORITY);
     DaemonThread.start(); 

     System.out.println("after connectToHPFServer ");
}

public Vector readRemoteFile(String host,int port,String file)
{
  
    URL url_file=null;
    String s=null;
    BufferedReader dos=null;
    URLConnection opc=null;
    Vector textFile = new Vector();
    
    try
      {
	url_file = new URL("http",host,port,file); 
      }catch (MalformedURLException ev){
      System.out.println("URL error " + ev);
    }
    
    System.out.println("URL for rece. file:"+url_file);
      
    try{
      opc = url_file.openConnection();
      dos = new  BufferedReader(new InputStreamReader(opc.getInputStream()));
      while((s = dos.readLine())!=null)
        textFile.addElement(s);
    }catch (IOException ev){
      System.out.println("IO error in getContent  "+ev);
    }
    return textFile;
    
}


public String StrValOfData(Object obj)
{
  String s = null;

  System.out.println("type = "+obj.getClass().getName());

  if ((obj.getClass().getName().indexOf("Integer")) >= 0){
    Integer val = (Integer)obj;
    s = val.toString();
  }
  else if ((obj.getClass().getName().indexOf("Character")) >= 0){
    Character val = (Character)obj;
    s = val.toString();
  } 
  else if ((obj.getClass().getName().indexOf("Short")) >= 0){
    Short val = (Short)obj;
    s = val.toString();
  }
  else if ((obj.getClass().getName().indexOf("Byte")) >= 0){
    Byte val = (Byte)obj;
    s = val.toString();
  }
  else if ((obj.getClass().getName().indexOf("Float")) >= 0){
    Float val = (Float)obj;
    s = val.toString();
  }
  else if ((obj.getClass().getName().indexOf("Double")) >= 0){
    Double val = (Double)obj;
    s = val.toString();
  }
  else if (obj.getClass().getName().equals("[I"))
    s = string1Dint((int[])obj);
  else if (obj.getClass().getName().equals("[[I"))
    s = string2Dint((int[][])obj);
  else if (obj.getClass().getName().equals("[[[I"))
    s = string3Dint((int[][][])obj);
  else if (obj.getClass().getName().equals("[F")) 
    s = string1Dfloat((float[])obj);
  else if (obj.getClass().getName().equals("[[F"))
    s = string2Dfloat((float[][])obj);
  else if (obj.getClass().getName().equals("[[[F"))
    s = string3Dfloat((float[][][])obj);

  else if (obj.getClass().getName().equals("[D")) 
    s = string1Ddouble((double[])obj);
  else if (obj.getClass().getName().equals("[[D"))
    s = string2Ddouble((double[][])obj);
  else if (obj.getClass().getName().equals("[[[D"))
    s = string3Ddouble((double[][][])obj);

  
  return s;

}

public String string1Dint(int[] a)
{
   String val="  ";

   for(int i=0;i<a.length;i++)
     val += Integer.toString(a[i])+"  ";
   return val;
}

public String string2Dint(int[][] a)
{
   String val="  ";

   for(int i=0;i<a.length;i++)
     for(int j=0;j<a[i].length;j++)
        val += Integer.toString(a[i][j])+"  ";
   return val;
}

public String string3Dint(int[][][] a)
{
   String val="  ";

   for(int i=0;i<a.length;i++)
     for(int j=0;j<a[i].length;j++)
       for(int k=0;k<a[i][j].length;k++)
        val += Integer.toString(a[i][j][k])+"  ";
   return val;
}

public String string1Dfloat(float[] a)
{
   String val="  ";

   for(int i=0;i<a.length;i++)
     val += Float.toString(a[i])+"  ";
   return val;
}

public String string2Dfloat(float[][] a)
{
   String val="  ";

   for(int i=0;i<a.length;i++)
     for(int j=0;j<a[i].length;j++)
        val +=  Float.toString(a[i][j])+"  ";
   return val;
}

public String string3Dfloat(float[][][] a)
{
   String val="  ";

   for(int i=0;i<a.length;i++)
     for(int j=0;j<a[i].length;j++)
       for(int k=0;k<a[i][j].length;k++)
         val +=  Float.toString(a[i][j][k])+"  ";
   return val;
}

public String string1Ddouble(double[] a)
{
   String val="  ";

   for(int i=0;i<a.length;i++)
     val += Double.toString(a[i])+"  ";
   return val;
}

public String string2Ddouble(double[][] a)
{
   String val="  ";

   for(int i=0;i<a.length;i++)
     for(int j=0;j<a[i].length;j++)
        val +=  Double.toString(a[i][j])+"  ";
   return val;
}

public String string3Ddouble(double[][][] a)
{
   String val="  ";

   for(int i=0;i<a.length;i++)
     for(int j=0;j<a[i].length;j++)
       for(int k=0;k<a[i][j].length;k++)
         val +=  Double.toString(a[i][j][k])+"  ";
   return val;
}

  public Object  recv_registrated_data(int []tag_type_ndims,String []avarName) 
    throws IOException
  {
    Object buffer=null;
    int []dims = null;

    // receive tag
    float fval ;
        
    int tag = rlib.recv_int();
    System.out.println("tag "+tag);
    
    String varName=rlib.recv_String().toString();
    System.out.println("varname "+varName);

    int type  = rlib.recv_int();
    System.out.println("type "+type);
    
    int ndims = rlib.recv_int();
    System.out.println("ndims "+ndims);
    
    int nelems = rlib.recv_int();
    System.out.println("nelems "+nelems);

    avarName[0] = varName;
    tag_type_ndims[0] = tag;
    tag_type_ndims[1] = type;
    tag_type_ndims[2] = ndims;
        
    if (ndims > 0){
      dims = new int[ndims];
      rlib.recv_1Dint_array(dims);
    }
    for(int s=3,i=0;i<ndims;i++)
      tag_type_ndims[s++] = dims[i];
    
    
    // System.out.println("RECEIVED  "+tag+" "+varName+" "+type+" "+ndims+" "+
    //		       nelems+" "+dims[0]+" "+dims[1] );
    //else
    System.out.println("RECEIVED  "+tag+" "+varName+" "+type+" "+ndims+" "+
    	       nelems+" ");
    switch(type){
    case javaGUI.T_INT:
      switch(ndims){
        case 0:
          int num = rlib.recv_int();
	  System.out.println("I received integer :"+num);
	  buffer = new Integer(num);
	  break;
        case 1:
	  buffer = new int[dims[0]];
	  rlib.recv_1Dint_array((int[])buffer);
	  break;
        case 2:  
          buffer = new int[dims[0]][dims[1]];
	  rlib.recv_2Dint_array((int[][])buffer);
	  break;
        case 3:
          buffer = new int[dims[0]][dims[1]][dims[2]];
	  rlib.recv_3Dint_array((int[][][])buffer);
	  break;
      }
      break;
      case javaGUI.T_CHAR:
      switch(ndims){
	case 0:
          char num = rlib.recv_char();
	  buffer = new Character(num);
	  break;
        case 1:
	  buffer = new char[dims[0]];
	  rlib.recv_1Dchar_array((char[])buffer);
	  break;
        case 2:  
          buffer = new char[dims[0]][dims[1]];
	  rlib.recv_2Dchar_array((char[][])buffer);
	  break;
        case 3:
          buffer = new char[dims[0]][dims[1]][dims[2]];
	  rlib.recv_3Dchar_array((char[][][])buffer);
	  break;
      }
      break;
      case javaGUI.T_FLOAT:
      switch(ndims){
	case 0:
          float num = rlib.recv_float();
	  buffer = new Float(num);
	  break;
        case 1:
	  buffer = new float[dims[0]];
	  rlib.recv_1Dfloat_array((float[])buffer);
	  break;
        case 2:  
          buffer = new float[dims[0]][dims[1]];
	  rlib.recv_2Dfloat_array((float[][])buffer);
	  break;
        case 3:
          buffer = new float[dims[0]][dims[1]][dims[2]];
	  rlib.recv_3Dfloat_array((float[][][])buffer);
	  break;
      }
      break;
      case javaGUI.T_LONG:
      switch(ndims){
	case 0:
          long num = rlib.recv_long();
	  buffer = new Long(num);
	  break;
        case 1:
	  buffer = new long[dims[0]];
	  rlib.recv_1Dlong_array((long[])buffer);
	  break;
        case 2:  
          buffer = new long[dims[0]][dims[1]];
	  rlib.recv_2Dlong_array((long[][])buffer);
	  break;
        case 3:
          buffer = new long[dims[0]][dims[1]][dims[2]];
	  rlib.recv_3Dlong_array((long[][][])buffer);
	  break;
      }
      break;
      case javaGUI.T_DOUBLE:
      switch(ndims){
	case 0:
          double num = rlib.recv_double();
	  buffer = new Double(num);
	  break;
        case 1:
	  buffer = new double[dims[0]];
	  rlib.recv_1Ddouble_array((double[])buffer);
	  break;
        case 2:  
          buffer = new double[dims[0]][dims[1]];
	  rlib.recv_2Ddouble_array((double[][])buffer);
	  break;
        case 3:
          buffer = new double[dims[0]][dims[1]][dims[2]];
	  rlib.recv_3Ddouble_array((double[][][])buffer);
	  break;
      }
      break;
      case javaGUI.T_BOOL:
      switch(ndims){
	case 0:
          boolean num = rlib.recv_boolean();
	  buffer = new Boolean(num);
	  break;
        case 1:
	  buffer = new boolean[dims[0]];
	  rlib.recv_1Dboolean_array((boolean[])buffer);
	  break;
        case 2:  
          buffer = new boolean[dims[0]][dims[1]];
	  rlib.recv_2Dboolean_array((boolean[][])buffer);
	  break;
        case 3:
          buffer = new boolean[dims[0]][dims[1]][dims[2]];
	  rlib.recv_3Dboolean_array((boolean[][][])buffer);
	  break;
      }
      break;
      case javaGUI.T_BYTE:
      switch(ndims){
	case 0:
          byte num = rlib.recv_byte();
	  buffer = new Byte(num);
	  break;
        case 1:
	  buffer = new byte[dims[0]];
	  rlib.recv_1Dbyte_array((byte[])buffer);
	  break;
        case 2:  
          buffer = new byte[dims[0]][dims[1]];
	  rlib.recv_2Dbyte_array((byte[][])buffer);
	  break;
        case 3:
          buffer = new byte[dims[0]][dims[1]][dims[2]];
	  rlib.recv_3Dbyte_array((byte[][][])buffer);
	  break;
      }
      break;
      case javaGUI.T_SHORT:
      switch(ndims){
        case 0:
          short num = rlib.recv_short();
	  buffer = new Short(num);
	  break;
        case 1:
	  buffer = new short[dims[0]];
	  rlib.recv_1Dshort_array((short[])buffer);
	  break;
        case 2:  
          buffer = new short[dims[0]][dims[1]];
	  rlib.recv_2Dshort_array((short[][])buffer);
	  break;
        case 3:
          buffer = new short[dims[0]][dims[1]][dims[2]];
	  rlib.recv_3Dshort_array((short[][][])buffer);
	  break;
      }
      break;
    }
    return buffer;
    
  }
  
  public void getArraySection_ack() throws IOException
  {

   // get result from HPF server
     statusInfo status = readAck(javaGUI.DISARRAYSECTION);
     if (status.retstatus() < 0)
        return ;  
  
     // parallel or local tag value (1:parallel 0:local)
     int isDistributed = rlib.recv_int();
     //get array expression
     String arrayExp = rlib.recv_String().toString();
     
     System.out.println("dist flag : "+isDistributed);

     // receive real data
     int []tag_type_ndims = new int[16];
     String []varName = new String[1];
     Object obj = recv_registrated_data(tag_type_ndims,varName) ;
     String varValue = StrValOfData(obj);    

     CommandEvent cev = new CommandEvent((Target)manager,"DisplayVar",
             arrayExp+"  :"+varValue+"\r\n");
     Application.application().eventLoop().addEvent(cev);
  }
  

  public void getArraySection(String arrayExp) throws IOException
  {
     int i,j,k,cnt,ndims,ncols;
     StringTokenizer st;
     String triplets[],tokens[],newtokens[];
     int nt;


     String save_arrayExp = arrayExp;
     
     System.out.println("input : "+arrayExp);
     st = new StringTokenizer(arrayExp,"(),");
     ndims = st.countTokens() -1 ;// omit array name;

     triplets  = new String[ndims];
     tokens    = new String[ndims*5];
     newtokens = new String[ndims*5];

     String varName = st.nextToken(); // pass Array Name;
     i = 0;
     while(st.hasMoreTokens())
       triplets[i++] = st.nextToken();

     k = 0;
     for(i=0,k=0;i<ndims;i++){
       st  = new StringTokenizer(triplets[i],": ",true);
       nt = 0;
       ncols = 0;
       while(st.hasMoreTokens()){
	 String tok = st.nextToken();
         if (!(tok.equals(" "))) 
            tokens[nt++] = tok;
         if (tok.equals(":"))
	   ncols++;
          
       }

       if (ncols == 0){
         newtokens[k] = new Integer(1).toString();
	 newtokens[k+1] = tokens[0];
         k+=2;
       }
       else if (ncols == 1){
         newtokens[k] =  new Integer(2).toString();
	 newtokens[k+1] = "X";
         newtokens[k+2] = "X";
         if (!(tokens[0].equals(":")))
	    newtokens[k+1] = tokens[0];
         if (!(tokens[nt-1].equals(":")))
	    newtokens[k+2] = tokens[nt-1];
         k+=3;
       }
       else if (ncols == 2){	
	 newtokens[k] =  new Integer(3).toString();
	 newtokens[k+1] = "X";
         newtokens[k+2] = "X";
         newtokens[k+3] = "X";
         if (!(tokens[0].equals(":"))){
	    newtokens[k+1] = tokens[0];
            if ( (tokens[1].equals(":"))&&
		(!(tokens[2].equals(":"))) )
              newtokens[k+2] = tokens[2];
         }
         else if (!(tokens[1].equals(":")))
              newtokens[k+2] = tokens[1];

         if (!(tokens[nt-1].equals(":")))
	    newtokens[k+3] = tokens[nt-1];
         k += 4;

       }
     }
     int subcripts[] = new int[k];
     for(j=0;j<k;j++){
       if (newtokens[j].equals("X"))
	 subcripts[j] = javaGUI.UNUSEDDIM;
       else
         subcripts[j] = new Integer(newtokens[j]).intValue();
     }
   
     //TAG+length of "arrayExp"+length of "varName" +k(4)+subcripts(k*4)
     int buflen = packed_string_length(save_arrayExp);
     buflen += packed_string_length(varName)+(subcripts.length)*4+12;
     send_command_tag(buflen,javaGUI.DISARRAYSECTION,selected_pids);
     slib.send_String(save_arrayExp);
     slib.send_String(varName); 
     slib.send_int(k); // send numbe of items
     slib.send_1Dint_array(subcripts);
     System.out.println("after sent disarraysection command "+arrayExp);
     
     
  }
  

  public boolean mouseDown(MouseEvent event)
  {
    
    super.mouseDown(event);
    curX = event.x;
    curY = event.y;
    currentRange  = paragraphForPoint(event.x,event.y);
    //System.out.println("event :"+event+"range "+crange);
    return true;
     
  }

  // HPFTextView ....
}



// Layout all the coponents using PackLayout
///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////

class DesignManager implements Target 
{
  Vector buttons;
  PackLayout layoutManager,ButtonsLayoutManager;
  PackLayout MenuLayoutManager; 
  PackConstraints constraints;
  InternalWindow window;
  ScrollGroup infoGroup;     
  public HPFTextView textSource;
  ContainerView ButtonView;//put debug buttons inside;
  ContainerView ControlMenuView;  //put menu inside; 
  ContainerView displayWindow;
  
  MenuView menuView;
  TextView StatusDisplayArea ;
  public RoundedButton getFileButton,runButton;
  
  
  public DesignManager()
  {
    window = new InternalWindow(0, 0, 700, 700);
    window.setResizable(true);
    window.setTitle("HPF Debugger/Visualization Tool");
    window.setCloseable(true);
    layoutManager = new PackLayout();
    window.contentView().setLayoutManager(layoutManager);
    //window.contentView().setColor(Color.pink);
    window.contentView().setColor(Color.lightGray);

    ButtonsLayoutManager = new PackLayout();
    ButtonView = new ContainerView(0,0,750,50);
    ButtonView.setLayoutManager(ButtonsLayoutManager);
    //ButtonView.setBackgroundColor(Color.pink);
    LineBorder lb = new  LineBorder(Color.red);
    ButtonView.setBorder(lb);

    try{
      textSource = new HPFTextView(0,0,800,450,this);
    }catch(IOException e){
    System.out.println("IOException in creating HPFtextview in Designmanager");
    }
    
    textSource.setBackgroundColor(Color.white);
    Font f = new Font("TimesRoman",Font.BOLD,16);
    textSource.setFont(f);
  
    displayWindow     = new ContainerView(0,0,800,100);
    StatusDisplayArea =  new TextView(0,0,800,100);
    StatusDisplayArea.setBackgroundColor(Color.pink);
    
  }
      
  public void addAllButtons()
  {
     addButton("Interpreter","interpreter.gif");
     addButton("Display","eval.gif");
     addButton("Setvar","setvar.gif");
     addButton("Break","break.gif");
     addButton("StepInto","stepinto.gif");
     addButton("StepOver","stepover.gif");
     addButton("NIteration","niteration.gif");
     addButton("Continue","continue.gif");
     addButton("GoUntil","gountil.gif");
     addButton("GoToCursor","runtocursor.gif");
     getFileButton = addButton("GetFile","editor.gif");
     addButton("StartManager","manager.gif");  
     runButton = addButton("Run","startdebugger.gif");
     addButton("Connect","connect.gif"); 
     addButton("Stop","stop.gif");
     addButton("Pause","pause.gif");
     addButton("MoveDown","movedownlevel.gif");
     addButton("MoveUp","moveuplevel.gif");
     addButton("SciViz","sciviz.gif");

     constraints = new PackConstraints();
     constraints.setSide(PackConstraints.SIDE_TOP);
     constraints.setAnchor(PackConstraints.ANCHOR_NORTHWEST);
     layoutManager.setConstraints(ButtonView ,constraints);
     window.addSubview(ButtonView);
  }


  public void addMenuItems()
  {
        MenuItem nm,menuItem;
    
        BezelBorder bb = new BezelBorder(BezelBorder.RAISED_BUTTON,
				Color.lightGray,Color.cyan,Color.magenta);
        Menu menu = new Menu(true);
        menu.setBorder(bb);
        menu.setBackgroundColor(Color.lightGray);
        
        menuItem = menu.addItemWithSubmenu("File    ");
        //menuItem.setSelectedColor(Color.pink);
        menuItem.submenu().setBackgroundColor(Color.lightGray);
        menuItem.submenu().setBorder(bb);
        nm = new  MenuItem("New","New",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,0);
	nm = new  MenuItem("Open","Open",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,1);    
        nm = new  MenuItem("Reload Source File","Reload",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,2);
        nm = new  MenuItem("Save","Save",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,3);


        menuItem = menu.addItemWithSubmenu("Edit     ");
        //menuItem.setSelectedColor(Color.pink);
        menuItem.submenu().setBackgroundColor(Color.lightGray);
        menuItem.submenu().setBorder(bb);
        nm = new  MenuItem("Undo","Undo",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,0);
	nm = new  MenuItem("Redo","Redo",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,1);    
        nm = new  MenuItem("Cut","Cut",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,2);
        nm = new  MenuItem("Copy","Copy",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,3);
        nm = new  MenuItem("Paste","Paste",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,4); 
        nm = new  MenuItem("Delete Line","Delete_Line",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,5); 
        nm = new  MenuItem("Insert Line","Insert_Line",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,6); 
        nm = new  MenuItem("Find","Find",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,7);
        nm = new  MenuItem("Replace","Replace",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,8);
        nm = new  MenuItem("Goto Line","GotoLine",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,9);
       

        menuItem = menu.addItemWithSubmenu("Debug     ");
        //menuItem.setSelectedColor(Color.pink);
        menuItem.submenu().setBackgroundColor(Color.lightGray);
        menuItem.submenu().setBorder(bb);
        nm = new  MenuItem("Start/Restart","Start/Restart",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,0);
	nm = new  MenuItem("Resume","Resume",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,1);    
        nm = new  MenuItem("Run to here","Runtohere",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,2);
        nm = new  MenuItem("Step Over","StepOver",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,3);
        nm = new  MenuItem("Step Into","StepInto",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,4); 
        nm = new  MenuItem("Evaluate","Evaluate",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,5); 
        nm = new  MenuItem("Breakpoints","Breakpoints",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,6); 
        nm = new  MenuItem("Goto Interpreter","GotoInterpreter",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,7); 


 
        menuItem = menu.addItemWithSubmenu("Preferences   ");
        //menuItem.setSelectedColor(Color.pink);
        menuItem.submenu().setBackgroundColor(Color.lightGray);
        menuItem.submenu().setBorder(bb);
        nm = new  MenuItem("Source Editor","SourceEditor",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,0);
	nm = new  MenuItem("Remote host","Remotehost",null);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,1);
	nm = new  MenuItem("Servers Port Numbers","Ports",textSource);
	//nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,1);


        menuView = new MenuView(0,0,600,100,menu);
   
        constraints = new PackConstraints();
        constraints.setInternalPadY(15);
        constraints.setPadY(5);
		
        constraints.setSide(PackConstraints.SIDE_TOP);
        constraints.setAnchor(PackConstraints.ANCHOR_NORTHWEST);
        layoutManager.setConstraints(menuView ,constraints);
        window.addSubview(menuView);
  }
  
  
  public  RoundedButton addButton(String title,String imgname)
  {
     RoundedButton button;
    
     button = new RoundedButton(1,1,1,1,title,imgname,textSource);
     //(1,1,30,30,title,imgname,textSource);
     ButtonView.addSubview(button);     
     constraints = new PackConstraints();
     constraints.setSide(PackConstraints.SIDE_LEFT);
     constraints.setAnchor(PackConstraints.ANCHOR_NORTH);
     ButtonsLayoutManager.setConstraints( button, constraints);
     return button;
  }
  
  public void addScrollBars ()
  {

      infoGroup = new ScrollGroup(0,0,600,450);
      infoGroup.setHasVertScrollBar(true); // Vertical only
      infoGroup.setBorder(new BezelBorder(BezelBorder.LOWERED,
                                            Color.lightGray));
      infoGroup.scrollView().setBackgroundColor(Color.white);
        // The following causes the bottom of the group to be fixed
        // (i.e., it's margin, the space below it, can stretch)
      infoGroup.setHasHorizScrollBar(true);
      infoGroup.setHasVertScrollBar(true);
      infoGroup.setVertResizeInstruction(View.BOTTOM_MARGIN_CAN_CHANGE);
      infoGroup.setHorizResizeInstruction(View.WIDTH_CAN_CHANGE);

      infoGroup.scrollView().setContentView(textSource);
       
      window.addSubview(infoGroup);
      constraints = new PackConstraints();
      constraints.setInternalPadY(180); 
      constraints.setPadY(20);
      constraints.setExpand(true);
      constraints.setFillX(true);
      constraints.setFillY(true);
      constraints.setSide(PackConstraints.SIDE_TOP);
      constraints.setAnchor(PackConstraints.ANCHOR_SOUTHWEST);
      layoutManager.setConstraints(infoGroup ,constraints);
  }

  public void addDisplayWindow()
  {

    ScrollGroup infoGroup = new ScrollGroup(0,0,700,100);
    infoGroup.setHasVertScrollBar(true); // Vertical only
    infoGroup.setBorder(new BezelBorder(BezelBorder.LOWERED,
					Color.lightGray));
    infoGroup.scrollView().setBackgroundColor(Color.white);
        // The following causes the bottom of the group to be fixed
        // (i.e., it's margin, the space below it, can stretch)
    infoGroup.setHasHorizScrollBar(true);
    infoGroup.setHasVertScrollBar(true);
    infoGroup.setVertResizeInstruction(View.BOTTOM_MARGIN_CAN_CHANGE);
    infoGroup.setHorizResizeInstruction(View.WIDTH_CAN_CHANGE);
    infoGroup.scrollView().setContentView(StatusDisplayArea);
    
    //displayWindow.setTitle("Display Window");
    //displayWindow.setBackgroundColor(Color.red);
    //displayWindow.addSubview(infoGroup);
    //window.addSubview(displayWindow);
    

    window.addSubview(infoGroup);
    constraints = new PackConstraints();
    constraints.setExpand(true);
    //constraints.setInternalPadY(150);
    //constraints.setPadY(10);
    constraints.setFillX(true);
    constraints.setFillY(true);
    constraints.setSide(PackConstraints.SIDE_TOP);
    constraints.setAnchor(PackConstraints.ANCHOR_SOUTHWEST);
    layoutManager.setConstraints(infoGroup ,constraints);
   
  }
  

  public void FinishDesign()
  {
     window.contentView().layoutView(0, 0);
     window.show();
  }

  public void performCommand(String command, Object anObject) 
  {
     
    if (command.equals("Display")){
       String s = (String)anObject; 
       int prevlen = StatusDisplayArea.length();
       StatusDisplayArea.appendString(s);
       StatusDisplayArea.scrollRangeToVisible(new Range(prevlen,
            StatusDisplayArea.length()-prevlen));
    }
    else if (command.equals("DisplayVar"))
       StatusDisplayArea.appendString((String)anObject);
  }
  
  
}



///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////

class RoundedButton extends Button implements Target{
    Bitmap bitmap = null;         // Stores a bitmap of the interior
    InternalWindow descW;
    TextField label;
    String titleCommand;
    MouseEvent lastEvent;
    
    // --------------  Constructors and initialization  --------------

    public RoundedButton(int x, int y, int width, int height,
           String title,String imgname, Object target) 
    {
        super(x, y, width, height);

        setImage(Bitmap.bitmapNamed(imgname));
        setTarget((Target)target);
        setCommand(title);
        titleCommand = title;
	
    }

   public void mouseEntered(MouseEvent e)
   {

      int x = x()+superview().x();
      int y = y()+superview().y();
      descW = new InternalWindow(x+width()/2,y+height()+3,150,35);

      descW.setResizable(true);
      descW.setType(Window.BLANK_TYPE);
      label = new TextField(0,0,150,35);
      label.setBackgroundColor(new Color(255,255,125));

      if (titleCommand.equals("Interpreter"))
        label.setStringValue("Interpret HPF Statements");
      else if (titleCommand.equals("Display"))
        label.setStringValue("Evaluate an Expression");
      else if (titleCommand.equals("Setvar"))
        label.setStringValue("Setting parameter");
      else if (titleCommand.equals("Break"))
        label.setStringValue("Toggle Breakpoint(F4)");
      else if (titleCommand.equals("StepInto"))
        label.setStringValue("Step into(Alt-Nstep)");
      else if (titleCommand.equals("StepOver"))
        label.setStringValue("Step over(Alt-Nstep)");
      else if (titleCommand.equals("GoUntil"))
        label.setStringValue("Go until true");
      else if (titleCommand.equals("GoToCursor"))
        label.setStringValue("Go to Cursor");
      else if (titleCommand.equals("NIter"))
        label.setStringValue("N iteration");
      else if (titleCommand.equals("Continue"))
        label.setStringValue("Continue");
      else if (titleCommand.equals("StartManager"))
        label.setStringValue("Start Manager");  

      else if (titleCommand.equals("Run"))
        label.setStringValue("Start Parallel Application");
      else if (titleCommand.equals("Stop"))
        label.setStringValue("Stop");
      else if (titleCommand.equals("Pause"))
        label.setStringValue("Pause");
      else if (titleCommand.equals("MoveDown"))
        label.setStringValue("Caller's stack frame");
      else if (titleCommand.equals("MoveUp"))
        label.setStringValue("Callee's stack frame");
      else if (titleCommand.equals("GetFile"))
	label.setStringValue("Get Project File");
      else if (titleCommand.equals("Connect"))
	label.setStringValue("Connect to Manager Server ");
      else if (titleCommand.equals("NIteration"))
	label.setStringValue("Make N iteration over loop"); 
      else if (titleCommand.equals("SciViz"))
	label.setStringValue("NPAC SciViz Tool");  
     
      
      descW.addSubview(label);
      this.superview().superview().addSubview(descW);
      descW.show();
     	
  }

  public void mouseExited(MouseEvent e)
  {
    descW.hide();
        
  }

  public boolean mouseDown(MouseEvent event)
  {

    lastEvent = event;
    super.mouseDown(event);
    return true;
     
  }
  
  public void closeLabelWin()
  {
    descW.hide();
  }

 
    
}

class readValue extends InternalWindow implements Target {

 TextField itemValue,second_itemValue;
 String labelText;
 Target target;
 String hpfCommand;
 TextField   entryTextField;
 TextField   second_entryTextField;
 String varName=null;

 public readValue(View parent,String labelText_,
          Object target_,String command_)  
 {
     super(parent.x()+ parent.width()/2,
	   parent.y()+ parent.height()/2,
	   300,300 );
     labelText = labelText_;
     target = (Target)target_;
     hpfCommand = command_;

     setTitle("Dialog Window");
     setResizable(true);
     setCloseable(true);

     contentView().setLayoutManager(new PackLayout());
     if (labelText.indexOf('+') >= 0){
         int index = labelText.indexOf('+');
	 String newlabel = labelText.substring(0,index);
	 entryTextField = newTextFieldRow(newlabel,"");
         newlabel = labelText.substring(index+1);
         second_entryTextField = newTextFieldRow(newlabel,"");
     }
     else
         entryTextField = newTextFieldRow(labelText,"");
  
     SelectButton();
     contentView().layoutView(0,0);
 }



 public TextField newTextFieldRow(String labelText,  String defaultValue)
   {
        PackLayout      layoutManager;
        PackConstraints constraints;
        ContainerView   containerView;
        TextField       label;
        TextField       entryTextField;

        containerView = newContainerView();
        containerView.setBorder(null);
        layoutManager = (PackLayout)containerView.layoutManager();

        label = new TextField(1, 1, 1,1);
        label.setBorder(null);
        label.setBackgroundColor(Color.lightGray);
        label.setStringValue(labelText);
        label.setEditable(false);
        label.setSelectable(false);
        label.sizeToMinSize();
        containerView.addSubview(label);
        constraints = new PackConstraints();
        constraints.setSide(PackConstraints.SIDE_LEFT);
        constraints.setPadX(2);
        layoutManager.setConstraints(label, constraints);
  
        entryTextField = new TextField(1,1,1,1);
        entryTextField.setStringValue(defaultValue);
        entryTextField.sizeToMinSize();
        containerView.addSubview(entryTextField);
        constraints.setExpand(true);
        constraints.setFillX(true);
        layoutManager.setConstraints(entryTextField, constraints);
        return entryTextField;
    }

 public ContainerView newContainerView() {
        ContainerView   containerView;
        PackLayout      layoutManager;
        PackConstraints constraints;

        containerView = new ContainerView(1, 1, 1,1);
        containerView.setLayoutManager(new PackLayout());
        contentView().addSubview(containerView);
        layoutManager = (PackLayout)contentView().layoutManager();
        constraints = new PackConstraints();
        constraints.setSide(PackConstraints.SIDE_TOP);
        constraints.setExpand(true);
        constraints.setFillX(true);
        constraints.setFillY(true);
        layoutManager.setConstraints(containerView, constraints);
        return containerView;
    }
   
    public void SelectButton()  {
        PackLayout      layoutManager;
        PackConstraints constraints;
        ContainerView   containerView;
        Button          button;

        containerView = newContainerView();
        containerView.setBorder(null);
        layoutManager = (PackLayout)containerView.layoutManager();

        button = new Button(1,1,1,1);
        button.setTitle("OK");
        button.setTarget(this);
        if (hpfCommand.equals("GetHPFSource"))
            button.setCommand("ForwardFileName");
        else if (hpfCommand.equals("GetSIntoNumber"))
            button.setCommand("ForwardNum");
        else if (hpfCommand.equals("GetSOverNumber"))
            button.setCommand("ForwardNum");
        else if (hpfCommand.equals("GetNumOfIterations"))
	    button.setCommand("ForwardNum");
        else if (hpfCommand.equals("GetBreakNumber"))
	    button.setCommand("ForwardNum");
        else if (hpfCommand.equals("GetVarValue"))
            button.setCommand("ForwardNameNum");
	else if (hpfCommand.equals("GetFunctionCall"))
            button.setCommand("ForwardNum");
        else if (hpfCommand.equals("GetArrayExp"))
            button.setCommand("ForwardNum");
        else if (hpfCommand.equals("GetVisServEnv"))
            button.setCommand("ForwardEnv");
	else if (hpfCommand.equals("GetVarName"))
	    button.setCommand("ForwardNum");
	else if (hpfCommand.equals("GetNameValEnv"))
	    button.setCommand("ForwardEnv");

        containerView.addSubview(button);
        constraints = new PackConstraints();
        constraints.setExpand(true);
        constraints.setFillX(true);
        constraints.setFillY(true);
        constraints.setPadY(35);
        constraints.setPadX(35);
        constraints.setSide(PackConstraints.ANCHOR_NORTH);//SIDE_LEFT);
        layoutManager.setConstraints(button, constraints);
    }

    public void performCommand(String command, Object anObject) 
    {
        System.out.println("new commmand in window :"+command);
        if (command.equals("ForwardFileName")) {
           CommandEvent evc=new CommandEvent(target,hpfCommand,entryTextField);
           Application.application().eventLoop().addEvent(evc);
        }  
        else if (command.equals("ForwardNum")) { 
           CommandEvent evc=new CommandEvent(target,hpfCommand,entryTextField);
           Application.application().eventLoop().addEvent(evc);
        }     
        else if (command.equals("ForwardNameNum")) {
           int i = labelText.indexOf(':');
           String msg =  labelText.substring(9,i-1);
           msg = msg +" "+ entryTextField.stringValue();
           CommandEvent evc=new CommandEvent(target,hpfCommand,msg);
           Application.application().eventLoop().addEvent(evc);
        } 
        else if (command.equals("ForwardEnv")) { 
	   String out = entryTextField.stringValue() +"+"+
	     second_entryTextField.stringValue();
           CommandEvent evc=new CommandEvent(target,hpfCommand,out);
           Application.application().eventLoop().addEvent(evc);
        }

    }
}

class readFromHttp extends Thread{
   DataInputStream is;

   public readFromHttp(DataInputStream is_)
   {
     is = is_;
     //setPriority(7);
   }
 
   public void run()
   {
     String thisLine;
     boolean flag = true;

     while(flag)
     {
        try{
             thisLine = is.readLine();
             System.out.println("here..."+thisLine);
         }catch (IOException ev){
	   System.out.println("IOException during reading ");}

         try{
              Thread.sleep(100);
         } catch (InterruptedException ie) {break;}
         Thread.yield();
      }
   }
}   



