#!/usr/local/bin/perl
#hpfprogram portnum -pghpf -np nprocs -host ...
# command line args :hpfprogram,hpfserver_portnum,sage_host,sage_portnum,
# scivis_host, scivis_port, and nprocs

print "Content-type : text/plain","\n\n";
print "We create child","\n";
require "set-env.pl";
&Define_Constants();

$ENV{"LD_LIBRARY_PATH"} = $LibDir.":$ENV{'LD_LIBRARY_PATH'}";
$ENV{"LD_LIBRARY_PATH"} = $DemoDir.":$ENV{'LD_LIBRARY_PATH'}:";

$ENV{"PGI"} = "/opt/PGI2.2";
chdir($DemoDir);

$libEnvs = "LIBS=$LibDir "." USERDIR=$DemoDir"; 

$progname       = $DemoDir.$ARGV[0];
$sage_port      = $ARGV[1];
$sage_host      = $ARGV[2];
$manager_port   = $ARGV[3];
$manager_host   = $ARGV[4];
$appType        = $ARGV[5]; #application type;
$scivis_port    = $ARGV[6];
$scivis_host    = $ARGV[7];
$nprocs         = $ARGV[8];

$sage_dir=substr($DemoDir,0,rindex($DemoDir,"/"));
print "PERL: LD_LIBRARY_PATH = $ENV{'LD_LIBRARY_PATH'} \n";
print "PERL:progname = $progname ,manager_port=$manager_port \n";
print "PERL:manager_host=$manager_host, apptype =$appType \n";
print "PERL:sage_host = $sage_host,sage_port=$sage_port \n";
print "PERL:scivis_host = $scivis_host,scivis_port=$scivis_port \n";
print "PERL:nprocs = $nprocs sageDir=$sage_dir\n";  

######################################################
# Do not forget to set the following environment variable. If you did not,
# pghpf compiler gives syntax errror for even right HPF programs
######################################################
$ENV{"PGI"} = "/opt/PGI2.2";
$ENV{"JSERHOST"} = $scivis_host;
$ENV{"JSERPORT"} = $scivis_port;

@hosts=("osprey4","osprey6","osprey7","osprey8","osprey1","osprey2");
$command = $progname."  ".$manager_port." $manager_host ";
$command .=" $appType "." $libEnvs " ;
$command .= " -pghpf -np  ".$nprocs."  -host ";
for($i=0;$i < $nprocs;$i++){
 $command .= $hosts[$i];
  if ($i < $nprocs-1){  
    $command .= ",";
  }  
}
print "PERL:$command \n";
if ($pid = fork()){
    $sageCommand = "rsh  $sage_host  ";
    $sageCommand .= "$ExecDir"."SageServer ".$sage_port." ".$sage_dir;
    $sageCommand .=  " ".$ExecDir;
    print "PERL: fork sageserver = $sageCommand \n"; 
    system($sageCommand);     
    print "We forked Sage Server \n";
  }
  else{
    $retval = system("$command");
    print "exit child \n";
  }





