#include <pthread.h>


typedef struct debCommandQ
{
  int commandTag; /* Command tag */
  int lineNumber; /* Line number used for some debugegr commands */
  int pid; /* target processor id */
  struct debCommandQ *next;
}DQUEUE;

/*DQUEUE          *command_q_tail=NULL, *command_q_head=NULL;
pthread_mutex_t command_q_mutex=PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t  command_q_cond =PTHREAD_COND_INITIALIZER;
*/

typedef struct ackQ
{
  int   errcode; /* error code */
  char  errmsg[4048];   /* holds the ack. message */
  int myline;
  int commandTag; /* Command tag */
  struct ackQ *next;
}ACKQ;

/*ACKQ              *ack_q_tail=NULL,*ack_q_head=NULL;
pthread_mutex_t   ack_q_mutex=PTHREAD_MUTEX_INITIALIZER;*/

/* Control thread makes one buffer all 
acknowledment and send in buffer. 
buf includes commandTag+pid+actualAckMessage   
commandTag : Command which causes this ack. 
pid: Source processor id which issues this ack. 
actualAckMessage : Actual ac. message */
